ig.module(
	'game.entities.damageBalls'
)
.requires(
	'impact.entity'
)
.defines(function(){

EntityDamageBalls = ig.Entity.extend({

	animSheet: new ig.AnimationSheet( 'media/img/game/balls.png', 60, 60 ),

	lostDelay : new ig.Timer(),
	
	collides: ig.Entity.COLLIDES.NEVER,
	
	init: function( x, y, settings ) {	
		this.lostDelay.pause();
		this.parent( x, y, settings );
	},
	
    update: function() {
	
		/* DamageBalls inactive and Rival hits the ball */
		if( ig.global.game.hits > 0 &&
			ig.global.game.hits % ig.global.damageBalls.cadence == 0 &&
			ig.game.getEntityByName('ball').vel.y > 0 &&
			this.vel.y == 0
			)
			{
				this.addAnim( 'default', 1, [ig.global.game.open - 1] );
				this.setScale(ig.global.damageBalls.height/60, ig.global.damageBalls.width/60);
				this.maxVel.x = 1000;
				this.maxVel.y = 5000;			
				this.pos.x = ig.game.getEntityByName('ball').pos.x;
				this.pos.y = ig.game.getEntityByName('ball').pos.y;
				if(Math.abs(ig.game.getEntityByName('ball').vel.x) < 150){
					if(ig.game.getEntityByName('ball').pos.x >= ig.global.game.center){
						this.vel.x = - (ig.game.getEntityByName('ball').pos.x - ig.global.court.x);
					}else{
						this.vel.x = (ig.global.court.x + ig.global.court.width) - ig.game.getEntityByName('ball').pos.x;
					};
				}else{
					this.vel.x = 0.09 * ig.game.getEntityByName('ball').vel.x;
				}
				this.vel.y = ig.global.court.height * ig.global.game.speed;
			}	
		
		/* Ball height effect */
		var resizer = 1 / (1 + Math.abs(this.pos.y - (ig.global.court.y + ig.global.court.height/2))/(ig.global.court.y + ig.global.court.height/2));
		this.setScale(ig.global.damageBalls.height/60 * resizer, ig.global.damageBalls.width/60 * resizer);		

		/* Ball out of pitch */
		if( this.pos.y > ig.global.game.height + 4 * this.size.y ){
			this.vel.y = 0;
		}			
		
		/* Player hits the damageBall */
		if( 
			this.pos.y >= ig.game.getEntityByName('player').pos.y + ig.global.player.height * 0.30 &&
			this.pos.y < ig.game.getEntityByName('player').pos.y + ig.global.player.height &&
			(		
				(
				this.pos.x >= ig.game.getEntityByName('player').pos.x &&
				this.pos.x <= ig.game.getEntityByName('player').pos.x + ig.global.player.width
				)
				||
				(
				this.pos.x + this.size.x  >= ig.game.getEntityByName('player').pos.x &&
				this.pos.x + this.size.x <= ig.game.getEntityByName('player').pos.x + ig.global.player.width	
				)			
			)
		){
			ig.game.playSound('damageBallSound');
			ig.global.game.paused = 1;
			ig.game.getEntityByName('ball').vel.x = 0;
			ig.game.getEntityByName('ball').vel.y = 0;
			this.vel.x = 0;
			this.vel.y = 0;			
			if(this.lostDelay.paused == 1){this.lostDelay.unpause();};
			if(this.lostDelay.delta() > 3){ig.game.lostGame();};
		}		
		
		this.parent();
    }
});

});