ig.module(
	'game.entities.disturbers'
)
.requires(
	'impact.entity'
)
.defines(function(){

EntityDisturbers = ig.Entity.extend({

	durationTimer : new ig.Timer(),
	
	cadenceTimer : new ig.Timer(),
	
	images : [
		0,
		new ig.Image( 'media/img/game/disturbers/ball1.png' ),
		new ig.Image( 'media/img/game/disturbers/ball2.png' )
	],
	
	collides: ig.Entity.COLLIDES.NEVER,
	
	init: function( x, y, settings ) {
		this.cadenceTimer.set(ig.global.disturbers.cadence);
		ig.global.disturbers.active = 0;		
		this.durationTimer.set(0);
		this.parent( x, y, settings );
	},
	
	draw : function(){
		this.parent();
		
			if(ig.global.disturbers.active > 0 && ig.global.game.paused == 0){
		
			var x = 0;
			var distanceX = ig.global.game.xmax - ig.global.court.x;
			var progress = this.durationTimer.delta()/ig.global.disturbers.fallDuration;
			if(this.durationTimer.delta() <= ig.global.disturbers.fallDuration * 0.3){
				var heightVariation = 0.3 + 0.7 * progress/0.3;
			}else{
				var heightVariation = 1 - (progress - 0.3)/0.7;
			}
				
			if(this.durationTimer.delta() < ig.global.disturbers.fallDuration){
		
				if(ig.global.disturbers.direction == 1){
					x = ig.global.game.xmin - ig.global.disturbers.item[ig.global.disturbers.active].width + (distanceX) * (progress);
				}else{
					x = ig.global.game.xmax - (distanceX) * (progress);
				}				
				
				var y = ig.global.disturbers.y + (ig.global.court.height/2 - ig.global.disturbers.item[ig.global.disturbers.active].height) * progress;
				var height = (1  + 1 * heightVariation) * ig.global.disturbers.item[ig.global.disturbers.active].height; 
				var width = (1 + 1 * heightVariation) * ig.global.disturbers.item[ig.global.disturbers.active].width; 
				ig.system.context.globalAlpha = 1;			
			
			}else{

				if(ig.global.disturbers.direction == 1){
					x = ig.global.game.xmin - ig.global.disturbers.item[ig.global.disturbers.active].width + (distanceX);
				}else{
					x = ig.global.game.xmax - + (distanceX);
				}				
			
				var y = ig.global.disturbers.y + ig.global.court.height/2 - ig.global.disturbers.item[ig.global.disturbers.active].height;
				var height = ig.global.disturbers.item[ig.global.disturbers.active].width; 
				var width = ig.global.disturbers.item[ig.global.disturbers.active].height;	
				ig.system.context.globalAlpha = ig.global.disturbers.fadeOutDuration - (this.durationTimer.delta() - ig.global.disturbers.fallDuration);
			}	
			ig.system.context.drawImage( this.images[ig.global.disturbers.active].data, x, y , width, height);
			ig.system.context.globalAlpha = 1;
		};
	},
	
    update: function() {
	
		if(ig.global.disturbers.active > 0 && this.durationTimer.delta() > ig.global.disturbers.fallDuration + ig.global.disturbers.fadeOutDuration){
			ig.global.disturbers.active = 0;
			this.durationTimer.pause();
			this.cadenceTimer.set(ig.global.disturbers.cadence);
		}
		
		if( this.cadenceTimer.delta() > 0 && ig.global.disturbers.active == 0 ) {
			ig.global.disturbers.active = 1 + Math.round(Math.random());
			switch(Math.round(Math.random())){
				case 0 : 
					ig.global.disturbers.x = ig.global.game.xmin - ig.global.disturbers.item[ig.global.disturbers.active].width ; 
					ig.global.disturbers.direction = 1; 
					break;
				case 1 : 
					ig.global.disturbers.x = ig.global.game.xmax + ig.global.disturbers.item[ig.global.disturbers.active].width ; 
					ig.global.disturbers.direction = -1; 
					break;
			}						
			ig.global.disturbers.y = (ig.global.court.y + ig.global.court.height/2);
			this.durationTimer.set(0);			
		};	  
		
		this.parent();
    }
});

});