ig.module(
	'game.entities.energizers'
)
.requires(
	'impact.entity'
)
.defines(function(){

EntityEnergizers = ig.Entity.extend({

	durationTimer : new ig.Timer(),
	cadenceTimer : new ig.Timer(),
	
	images : [
		0,
		new ig.Image( 'media/img/game/energizers/banana.png' ),
		new ig.Image( 'media/img/game/energizers/bottle.png' ),
		new ig.Image( 'media/img/game/energizers/chocolate.png' ),		
		new ig.Image( 'media/img/game/energizers/watermelon.png' )
	],
	
	collides: ig.Entity.COLLIDES.NEVER,

	init: function( x, y, settings ) {
		ig.global.energizers.active = 0;		
		this.durationTimer.set(0);		
		this.parent( x, y, settings );
	},
	
	draw : function(){
		this.parent();
		if(ig.global.energizers.active > 0){
			if(Math.abs(this.durationTimer.delta())<=1){
				ig.system.context.globalAlpha = Math.abs(this.durationTimer.delta());
			}else{
				ig.system.context.globalAlpha = 1;
			}
			ig.system.context.drawImage( this.images[ig.global.energizers.active].data, ig.global.energizers.x, ig.global.player.y + ig.global.player.width - ig.global.energizers.height, ig.global.energizers.width, ig.global.energizers.height );
			ig.system.context.globalAlpha = 1;
		};
	},
	
    update: function() {
	
		if(ig.global.energizers.active > 0 && this.durationTimer.delta() > 0 ){
			ig.global.energizers.active = 0;
			this.durationTimer.pause();
			this.cadenceTimer.set(ig.global.energizers.cadence);
		}
		
		if( ig.global.game.life <= ig.global.energizers.minLife && ig.global.energizers.active == 0 && this.cadenceTimer.delta() > 0 ) {
			ig.global.energizers.active = 1 + Math.round(Math.random() * 3);
			if ( ig.game.getEntityByName('player').pos.x > ig.global.game.center ){
				ig.global.energizers.x = Math.round(ig.global.court.x);
			}else{
				ig.global.energizers.x = Math.round(ig.global.court.x + ig.global.court.width - ig.global.energizers.width);
			}	
			this.durationTimer.set(ig.global.energizers.duration);			
		};	  
		
		if( ig.global.energizers.active > 0 && 
			(
				(
					ig.game.getEntityByName('player').pos.x >= ig.global.energizers.x && 
					ig.game.getEntityByName('player').pos.x <= ig.global.energizers.x + ig.global.energizers.width
				)
				||
				(
					ig.global.energizers.x >= ig.game.getEntityByName('player').pos.x && 
					ig.global.energizers.x <= ig.game.getEntityByName('player').pos.x + ig.global.player.width)			
				)
			){
			ig.game.playSound('energizerSound');
			ig.global.energizers.active = 0;
			ig.global.game.life = ig.global.game.maxLife;
		};
		
		this.parent();
    }
});

});