ig.module(
	'game.entities.homeScreen'
)
.requires(
	'impact.entity'
)
.defines(function(){

EntityHomeScreen = ig.Entity.extend({

	collides: ig.Entity.COLLIDES.NEVER,
	
	durationTimer : new ig.Timer(),

	homeBackground : new ig.Image( 'media/img/ui/home/background.png' ),
	homeNadal : new ig.Image( 'media/img/ui/home/nadal.png' ),
	homeTitle : new ig.Image( 'media/img/ui/home/title.png' ),		
	homeLogo : new ig.Image( 'media/img/ui/home/logo.png' ),	

	init: function( x, y, settings ) {
		this.durationTimer.set(0);
		this.parent( x, y, settings );
	},
	
	draw: function() {  
		this.parent();
		var ctx = ig.system.context;
		
		/* Plain Background */
		ctx.fillStyle= "#76af0a";
		ctx.fillRect( ig.global.game.xmin, 0, ig.global.game.width, ig.global.game.height );		
		
		/* Home Background */
		ig.system.context.drawImage( this.homeBackground.data, ig.global.homeScreen.background.x, ig.global.homeScreen.background.y, ig.global.homeScreen.background.width, ig.global.homeScreen.background.height );

		/* Home Nadal */
		if(this.durationTimer.delta()<2){
			var d = ig.global.tutorialScreen.easingTime;
			ig.system.context.globalAlpha = ig.auxiliar.outExpo(this.durationTimer.delta());
			var x = ig.global.homeScreen.nadal.x * (1.1 - 0.1 * ig.auxiliar.outExpo(this.durationTimer.delta()));
		}else{
			var x = ig.global.homeScreen.nadal.x;
		}
		ig.system.context.drawImage( this.homeNadal.data, x, ig.global.homeScreen.nadal.y, ig.global.homeScreen.nadal.width, ig.global.homeScreen.nadal.height );
		ig.system.context.globalAlpha = 1;

		/* Home Title */
		if(this.durationTimer.delta()<0.5){
			ig.system.context.globalAlpha = ig.auxiliar.outExpo(this.durationTimer.delta()/0.5);
			var width = ig.global.homeScreen.title.width * (0.8 + 0.2 * ig.auxiliar.outExpo(this.durationTimer.delta()/0.5));
			var height = ig.global.homeScreen.title.height * (0.8 + 0.2 * ig.auxiliar.outExpo(this.durationTimer.delta()/0.5));
			var x = ig.global.game.center - width/2;
			var y = ig.global.homeScreen.title.y;
		}else{
			var width = ig.global.homeScreen.title.width;
			var height = ig.global.homeScreen.title.height;
			var x = ig.global.game.center - width/2;
			var y = ig.global.homeScreen.title.y;
		}
		ig.system.context.drawImage( this.homeTitle.data, x, y, width, height);
		ig.system.context.globalAlpha = 1;
		
		/* Topbar */
		var grd = ctx.createLinearGradient(0,0,ig.global.game.width,ig.global.homeScreen.topBar.height);
		grd.addColorStop(0,"#fdfdfd");
		grd.addColorStop(1,"#f0f0f0");
		ctx.fillStyle= grd;
		ctx.fillRect( ig.global.game.xmin, 0, ig.global.game.width, ig.global.homeScreen.topBar.height );
		
		/* Home logo */
		ig.system.context.drawImage( this.homeLogo.data, ig.global.homeScreen.homeLogo.x, ig.global.homeScreen.homeLogo.y, ig.global.homeScreen.homeLogo.width, ig.global.homeScreen.homeLogo.height );		
		
		/* Exit Button */
		ctx.fillStyle = "#d97609";	
		ig.auxiliar.radiusRectangle(ctx, ig.global.homeScreen.exitButton.x, ig.global.homeScreen.exitButton.pressedY , ig.global.homeScreen.exitButton.width, ig.global.homeScreen.exitButton.height, ig.global.homeScreen.exitButton.height/8, 1, 0);
		grd = ctx.createLinearGradient(ig.global.homeScreen.exitButton.x, ig.global.homeScreen.exitButton.y, ig.global.homeScreen.exitButton.x, ig.global.homeScreen.exitButton.y + ig.global.homeScreen.exitButton.height);
		grd.addColorStop(0,"#ffde00");
		grd.addColorStop(1,"#fea812");		
		ctx.fillStyle = grd;
		ig.auxiliar.radiusRectangle(ctx, ig.global.homeScreen.exitButton.x, ig.global.homeScreen.exitButton.y , ig.global.homeScreen.exitButton.width, ig.global.homeScreen.exitButton.height, ig.global.homeScreen.exitButton.height/8, 1, 0);
			/* Exit Symbol */
			ctx.fillStyle = '#FFFFFF';
			var textFontSize = Math.floor(ig.global.homeScreen.exitButton.height * 0.8);
			var textX = ig.global.homeScreen.exitButton.x + Math.floor(ig.global.homeScreen.exitButton.width * 0.5);
			var textY = ig.global.homeScreen.exitButton.y + Math.floor(ig.global.homeScreen.exitButton.height * 0.5);	
			ctx.font= textFontSize + "px icomoon";
			ctx.textBaseline = 'middle';		
			ctx.textAlign = 'center';	
			ctx.fillText( "q", textX, textY );	

		if(this.durationTimer.delta() > 0){			
		
			if(this.durationTimer.delta()< 0.5){
				var buttonY = ig.global.homeScreen.playButton.y + ig.global.game.height * (1 - ig.auxiliar.outExpo((this.durationTimer.delta() - 0)/0.5));
				var buttonPressedY = ig.global.homeScreen.playButton.pressedY + ig.global.game.height * (1 - ig.auxiliar.outExpo((this.durationTimer.delta() - 0)/0.5));
			}else{
				var buttonY = ig.global.homeScreen.playButton.y ;
				var buttonPressedY = ig.global.homeScreen.playButton.pressedY;
			}
		
			/* Play Button */
			ctx.fillStyle = "#034462";	
			ig.auxiliar.radiusRectangle(ctx, ig.global.homeScreen.playButton.x, buttonPressedY , ig.global.homeScreen.playButton.width, ig.global.homeScreen.playButton.height, ig.global.homeScreen.playButton.height/8, 1, 0);
			var grd = ctx.createLinearGradient(ig.global.homeScreen.playButton.x, buttonY, ig.global.homeScreen.playButton.x , buttonY + ig.global.homeScreen.playButton.height);
			grd.addColorStop(0,"#006282");
			grd.addColorStop(1,"#008598");		
			ctx.fillStyle = grd;
			ig.auxiliar.radiusRectangle(ctx, ig.global.homeScreen.playButton.x, buttonY , ig.global.homeScreen.playButton.width, ig.global.homeScreen.playButton.height, ig.global.homeScreen.playButton.height/8, 1, 0);
			var textFontSize = Math.floor(ig.global.homeScreen.playButton.height * 0.8);
			var textX = ig.global.homeScreen.playButton.x + Math.floor(ig.global.homeScreen.playButton.width * 0.5);
			var textY = buttonY + Math.floor(ig.global.homeScreen.playButton.height * 0.55);
			ctx.fillStyle = '#FFFFFF';
			ctx.font= textFontSize + "px HauracherellNC";
			ctx.textBaseline = 'middle';			
			ctx.textAlign = 'center';		
			
			ctx.fillText( "JUGAR", textX, textY );
			
			ig.system.context.globalAlpha = 1;		
		};
		
		if(this.durationTimer.delta() > 0.15){	
		
			if(this.durationTimer.delta() < 0.65){
				var buttonY = ig.global.homeScreen.tutorialButton.y + ig.global.game.height * (1 - ig.auxiliar.outExpo((this.durationTimer.delta() - 0.15)/0.5));
				var buttonPressedY = ig.global.homeScreen.tutorialButton.pressedY + ig.global.game.height * (1 - ig.auxiliar.outExpo((this.durationTimer.delta() - 0.15)/0.5));
			}else{
				var buttonY = ig.global.homeScreen.tutorialButton.y ;
				var buttonPressedY = ig.global.homeScreen.tutorialButton.pressedY;
			}
			
			/* Tutorial Button */
			ctx.fillStyle = "#d47800";	
			ig.auxiliar.radiusRectangle(ctx, ig.global.homeScreen.tutorialButton.x, buttonPressedY , ig.global.homeScreen.tutorialButton.width, ig.global.homeScreen.tutorialButton.height, ig.global.homeScreen.tutorialButton.height/8, 1, 0);
			grd = ctx.createLinearGradient(ig.global.homeScreen.tutorialButton.x, buttonY, ig.global.homeScreen.tutorialButton.x, buttonY + ig.global.homeScreen.tutorialButton.height);
			grd.addColorStop(0,"#ffde00");
			grd.addColorStop(1,"#fea812");		
			ctx.fillStyle = grd;
			ig.auxiliar.radiusRectangle(ctx, ig.global.homeScreen.tutorialButton.x, buttonY , ig.global.homeScreen.tutorialButton.width, ig.global.homeScreen.tutorialButton.height, ig.global.homeScreen.tutorialButton.height/8, 1, 0);
			var textFontSize = Math.floor(ig.global.homeScreen.tutorialButton.height*0.8);
			var textX = ig.global.homeScreen.tutorialButton.x + Math.floor(ig.global.homeScreen.tutorialButton.width * 0.5);
			var textY = buttonY + Math.floor(ig.global.homeScreen.tutorialButton.height * 0.55);
			ctx.fillStyle = '#FFFFFF';
			ctx.font= textFontSize + "px HauracherellNC";
			ctx.textBaseline = 'middle';			
			ctx.textAlign = 'center';		
			ctx.fillText( "TUTORIAL", textX, textY );	

			ig.system.context.globalAlpha = 1;
			
		};
		
	},
	
    update: function() {
		 
		if(ig.global.game.paused == 1){
		
			if(this.durationTimer.delta() > 1.2){
			
				/* Play Button */ 
				ig.auxiliar.button(ig.global.homeScreen.playButton);
				
				if( lastClick.x >= ig.global.homeScreen.playButton.x && lastClick.x <= ig.global.homeScreen.playButton.x + ig.global.homeScreen.playButton.width &&  lastClick.y >= ig.global.homeScreen.playButton.y && lastClick.y <= ig.global.homeScreen.playButton.y + ig.global.homeScreen.playButton.height &&
					release.x >= ig.global.homeScreen.playButton.x && release.x <= ig.global.homeScreen.playButton.x + ig.global.homeScreen.playButton.width &&  release.y >= ig.global.homeScreen.playButton.y && release.y <= ig.global.homeScreen.playButton.y + ig.global.homeScreen.playButton.height ){
					clearMouse();
					ig.game.launchLevelsMenu();
				};	
			
			}

			if(this.durationTimer.delta() > 1.2){
				
				/* Tutorial Button */ 
				ig.auxiliar.button(ig.global.homeScreen.tutorialButton);
				
				if( 
					lastClick.x >= ig.global.homeScreen.tutorialButton.x && lastClick.x <= ig.global.homeScreen.tutorialButton.x + ig.global.homeScreen.tutorialButton.width &&  lastClick.y >= ig.global.homeScreen.tutorialButton.y && lastClick.y <= ig.global.homeScreen.tutorialButton.y + ig.global.homeScreen.tutorialButton.height &&
					release.x >= ig.global.homeScreen.tutorialButton.x && release.x <= ig.global.homeScreen.tutorialButton.x + ig.global.homeScreen.tutorialButton.width &&  release.y >= ig.global.homeScreen.tutorialButton.y && release.y <= ig.global.homeScreen.tutorialButton.y + ig.global.homeScreen.tutorialButton.height ){
					clearMouse();
					ig.game.launchTutorial();
				};	
				
			};

			/* Exit Button */ 
			ig.auxiliar.button(ig.global.homeScreen.exitButton);
			
			if( 
			lastClick.x >= ig.global.homeScreen.exitButton.x && lastClick.x <= ig.global.homeScreen.exitButton.x + ig.global.homeScreen.exitButton.width &&  lastClick.y >= ig.global.homeScreen.exitButton.y && lastClick.y <= ig.global.homeScreen.exitButton.y + ig.global.homeScreen.exitButton.height  &&
			release.x >= ig.global.homeScreen.exitButton.x && release.x <= ig.global.homeScreen.exitButton.x + ig.global.homeScreen.exitButton.width &&  release.y >= ig.global.homeScreen.exitButton.y && release.y <= ig.global.homeScreen.exitButton.y + ig.global.homeScreen.exitButton.height 
			){
				clearMouse();
				ig.game.exit();
			};		
			
		};
		this.parent();
    }	
   
});

});