ig.module(
	'game.entities.levelScreen'
)
.requires(
	'impact.entity'
)
.defines(function(){

EntityLevelScreen = ig.Entity.extend({

	collides: ig.Entity.COLLIDES.NEVER,
	
	durationTimer : new ig.Timer(),
	startingDelay : new ig.Timer(),	

	levelImage : [
		new ig.Image( 'media/img/ui/levels/01.png' ),
		new ig.Image( 'media/img/ui/levels/02.png' ),
		new ig.Image( 'media/img/ui/levels/03.png' ),
		new ig.Image( 'media/img/ui/levels/04.png' )
	],

	init: function( x, y, settings ) {
		clearMouse();	
		this.startingDelay.set(1);
		this.durationTimer.set(ig.global.levelScreen.easingTime);
		this.parent( x, y, settings );
	},
	
	draw: function() {  
	
		this.parent();
		var ctx = ig.system.context;

		/* Plain Background */
		ctx.fillStyle= "#ffffff";
		ctx.fillRect( ig.global.game.xmin, 0, ig.global.game.width, ig.global.game.height );		
		
		/* Topbar */
		var grd = ctx.createLinearGradient(0,0,ig.global.game.width,ig.global.levelScreen.topBar.height);
		grd.addColorStop(0,"#006e91");
		grd.addColorStop(1,"#035d7a");
		ctx.fillStyle= grd;
		ctx.fillRect( ig.global.game.xmin, 0, ig.global.game.width, ig.global.levelScreen.topBar.height );
		
		/* Title */
		ctx.fillStyle = '#ffd51b';
		var textFontSize = ig.global.levelScreen.title.height;
		var textX = ig.global.levelScreen.title.x;
		var textY = ig.global.levelScreen.title.y;
		ctx.font= textFontSize + "px HauracherellNC";
		ctx.textBaseline = 'middle';		
		ctx.textAlign = 'left';	
		ctx.fillText( "Presentación", textX, textY );
		
		/* Home Button */
		ctx.fillStyle = "#d97609";	
		ig.auxiliar.radiusRectangle(ctx, ig.global.levelScreen.backButton.x, ig.global.levelScreen.backButton.pressedY , ig.global.levelScreen.backButton.width, ig.global.levelScreen.backButton.height, ig.global.levelScreen.backButton.height/8, 1, 0);
		grd = ctx.createLinearGradient(ig.global.levelScreen.backButton.x, ig.global.levelScreen.backButton.y, ig.global.levelScreen.backButton.x, ig.global.levelScreen.backButton.y + ig.global.levelScreen.backButton.height);
		grd.addColorStop(0,"#ffde00");
		grd.addColorStop(1,"#fea812");		
		ctx.fillStyle = grd;
		ig.auxiliar.radiusRectangle(ctx, ig.global.levelScreen.backButton.x, ig.global.levelScreen.backButton.y , ig.global.levelScreen.backButton.width, ig.global.levelScreen.backButton.height, ig.global.levelScreen.backButton.height/8, 1, 0);
			/* Back Symbol */
			ctx.fillStyle = '#FFFFFF';
			var textFontSize = Math.floor(ig.global.levelScreen.backButton.height * 0.5);
			var textX = ig.global.levelScreen.backButton.x + Math.floor(ig.global.levelScreen.backButton.width * 0.5);
			var textY = ig.global.levelScreen.backButton.y + Math.floor(ig.global.levelScreen.backButton.height * 0.5);	
			ctx.font= textFontSize + "px icomoon";
			ctx.textBaseline = 'middle';		
			ctx.textAlign = 'center';	
			ctx.fillText( "b", textX, textY );
			
		/* Image Area */
		var grd = ctx.createLinearGradient(0,ig.global.levelScreen.imageArea.y,0,ig.global.levelScreen.imageArea.y + ig.global.levelScreen.imageArea.height);
		grd.addColorStop(0,"#ffffff");
		grd.addColorStop(1,"#dbdbdb");
		ctx.fillStyle= grd;
		ctx.fillRect( ig.global.game.xmin, ig.global.levelScreen.imageArea.y, ig.global.game.width, ig.global.levelScreen.imageArea.height );		
		
			/* Image */
			if(this.durationTimer.delta() < 0){ 
				ig.system.context.globalAlpha = ig.auxiliar.outExpo(1 - Math.abs(this.durationTimer.delta())/ig.global.levelScreen.easingTime)
				var moveY = ig.global.levelScreen.image.y - 0.05 * ig.global.game.height * (1 - ig.auxiliar.outExpo(1 - Math.abs(this.durationTimer.delta())/ig.global.levelScreen.easingTime));
			}else{
				var moveY = ig.global.levelScreen.image.y;
			}
			ig.system.context.drawImage( this.levelImage[ig.global.game.open - 1].data, ig.global.levelScreen.image.x, moveY, ig.global.levelScreen.image.width, ig.global.levelScreen.image.height );
			ig.system.context.globalAlpha = 1;
		
		/* Bubble + Text */
		if(this.durationTimer.delta() < 0){ 
			ig.system.context.globalAlpha = ig.auxiliar.outExpo(1 - Math.abs(this.durationTimer.delta())/ig.global.levelScreen.easingTime)
			var moveY = ig.global.levelScreen.bubble.y + 0.05 * ig.global.game.height * (1 - ig.auxiliar.outExpo(1 - Math.abs(this.durationTimer.delta())/ig.global.levelScreen.easingTime));			
			
		}else{
			var moveY = ig.global.levelScreen.bubble.y;
		}			
		ctx.fillStyle = '#006e91';
		ig.auxiliar.radiusRectangle(ctx, ig.global.levelScreen.bubble.x, moveY , ig.global.levelScreen.bubble.width, ig.global.levelScreen.bubble.height, ig.global.levelScreen.bubble.height/50, 1, 0);
		//Bubble Triangle
		ctx.moveTo(ig.global.levelScreen.bubbleTriangle.x1, moveY);
		ctx.lineTo(ig.global.levelScreen.bubbleTriangle.xc, moveY - ig.global.levelScreen.bubbleTriangle.height);
		ctx.lineTo(ig.global.levelScreen.bubbleTriangle.x2, moveY);
		ctx.lineTo(ig.global.levelScreen.bubbleTriangle.x1, moveY);		
		ctx.fill();		
		//Text
		ctx.fillStyle = '#FFFFFF';
		ig.auxiliar.levelText(ctx,ig.global.game.open,moveY);
	
		
		ig.system.context.globalAlpha = 1;

		/* Bottombar */
		var grd = ctx.createLinearGradient(ig.global.game.xmin, ig.global.levelScreen.bottomBar.y, ig.global.game.xmin, ig.global.levelScreen.bottomBar.y + ig.global.levelScreen.bottomBar.height);
		grd.addColorStop(0,"#006e91");
		grd.addColorStop(1,"#035d7a");
		ctx.fillStyle= grd;
		ctx.fillRect( ig.global.game.xmin, ig.global.levelScreen.bottomBar.y, ig.global.game.width, ig.global.levelScreen.bottomBar.height );		
		
		if(this.startingDelay.delta() < 0){
			var d = ig.global.tutorialScreen.easingTime;
			moveY = ig.global.levelScreen.playButton.y + 0.1 * ig.global.game.height * (1 - (ig.auxiliar.outExpo(1 - Math.abs(this.startingDelay.delta()))));
			pressedY = ig.global.levelScreen.playButton.pressedY + 0.1 * ig.global.game.height * (1 - (ig.auxiliar.outExpo(1 - Math.abs(this.startingDelay.delta()))));
		}else{
			moveY = ig.global.levelScreen.playButton.y;
			pressedY = ig.global.levelScreen.playButton.pressedY;
		};
		
		/* Play Again Button */
		ctx.fillStyle = "#d47800";	
		ig.auxiliar.radiusRectangle(ctx, ig.global.levelScreen.playButton.x, pressedY, ig.global.levelScreen.playButton.width, ig.global.levelScreen.playButton.height, ig.global.levelScreen.playButton.height/8, 1, 0);
		grd = ctx.createLinearGradient(ig.global.levelScreen.playButton.x, moveY, ig.global.levelScreen.playButton.x, moveY + ig.global.levelScreen.playButton.height);
		grd.addColorStop(0,"#ffde00");
		grd.addColorStop(1,"#fea812");		
		ctx.fillStyle = grd;
		ig.auxiliar.radiusRectangle(ctx, ig.global.levelScreen.playButton.x, moveY , ig.global.levelScreen.playButton.width, ig.global.levelScreen.playButton.height, ig.global.levelScreen.playButton.height/8, 1, 0);
		var textFontSize = Math.floor(ig.global.levelScreen.playButton.height * 0.7);
		var textX = ig.global.levelScreen.playButton.x + Math.floor(ig.global.levelScreen.playButton.width * 0.5);
		var textY = moveY + Math.floor(ig.global.levelScreen.playButton.height * 0.55);
		ctx.fillStyle = '#FFFFFF';
		ctx.font= textFontSize + "px HauracherellNC";
		ctx.textBaseline = 'middle';			
		ctx.textAlign = 'center';		
		ctx.fillText( "JUGAR", textX, textY );	

	},
	
    update: function() {

		/* Back Button */ 
		ig.auxiliar.button(ig.global.levelScreen.backButton);
		
		if( 
		lastClick.x >= ig.global.levelScreen.backButton.x && lastClick.x <= ig.global.levelScreen.backButton.x + ig.global.levelScreen.backButton.width &&  lastClick.y >= ig.global.levelScreen.backButton.y && lastClick.y <= ig.global.levelScreen.backButton.y + ig.global.levelScreen.backButton.height  &&
		release.x >= ig.global.levelScreen.backButton.x && release.x <= ig.global.levelScreen.backButton.x + ig.global.levelScreen.backButton.width &&  release.y >= ig.global.levelScreen.backButton.y && release.y <= ig.global.levelScreen.backButton.y + ig.global.levelScreen.backButton.height 
		){
			clearMouse();
			ig.game.launchLevelsMenu();
		};		
		
		if(this.startingDelay.delta()>0){
		
			/* Play Button */
			ig.auxiliar.button(ig.global.levelScreen.playButton);
			
			if( 
			lastClick.x >= ig.global.levelScreen.playButton.x && lastClick.x <= ig.global.levelScreen.playButton.x + ig.global.levelScreen.playButton.width &&  lastClick.y >= ig.global.levelScreen.playButton.y && lastClick.y <= ig.global.levelScreen.playButton.y + ig.global.levelScreen.playButton.height &&
			release.x >= ig.global.levelScreen.playButton.x && release.x <= ig.global.levelScreen.playButton.x + ig.global.levelScreen.playButton.width &&  release.y >= ig.global.levelScreen.playButton.y && release.y <= ig.global.levelScreen.playButton.y + ig.global.levelScreen.playButton.height 
			){
				ig.game.launchGame();
				clearMouse();
			};		
		
		};
	
		this.parent();
		
    }
   
});

});