ig.module(
	'game.entities.levelsMenuScreen'
)
.requires(
	'impact.entity'
)
.defines(function(){

EntityLevelsMenuScreen = ig.Entity.extend({

	collides: ig.Entity.COLLIDES.NEVER,
	
	startingDelay : new ig.Timer(),	
	
	levelFlag : [
		new ig.Image( 'media/img/ui/levels/flag01.png' ),
		new ig.Image( 'media/img/ui/levels/flag02.png' ),
		new ig.Image( 'media/img/ui/levels/flag03.png' ),
		new ig.Image( 'media/img/ui/levels/flag04.png' ),
		],
		
	cityText : ["Melbourne","París","Londres","Nueva York"],

	init: function( x, y, settings ) {
		clearMouse();
		this.startingDelay.set(1);		
		this.parent( x, y, settings );
	},
	
	draw: function() {  
	
		this.parent();
		var ctx = ig.system.context;
		
		/* Fill background */
		ctx.fillStyle = "white";
		ctx.fillRect(ig.global.game.xmin,0,ig.global.game.width,ig.global.game.height);
			
		/* Opens */
		for(var i=0;i<=3;i++){
			var openH = ig.global.levelsMenuScreen.open.height;
			var openY = ig.global.levelsMenuScreen.open.scroll + i * openH;
			var easingSpeed = 0.25;
			
			if(this.startingDelay.delta() <= - easingSpeed * (4-i)){
				var openY = ig.global.game.height;
			}else if (this.startingDelay.delta() > - easingSpeed * (4-i) && this.startingDelay.delta() < - easingSpeed * (3-i)){
				t = 1 - (Math.abs(this.startingDelay.delta())%easingSpeed)/easingSpeed;
				var openY = ig.global.levelsMenuScreen.open.scroll + i * openH + 0.25  * ig.global.game.height * (1 - (ig.auxiliar.outExpo(t)));					
			}else{
				var openY = ig.global.levelsMenuScreen.open.scroll + i * openH;
			};			

			/* Background */
			var grd = ctx.createLinearGradient(0, openY, 0, openY + openH);
			grd.addColorStop(0,"#ffffff");
			grd.addColorStop(1,"#dbdbdb");
			ctx.fillStyle= grd;
			ctx.fillRect( ig.global.game.xmin, openY , ig.global.game.width, openH );

			/* City Text and Flag vars */
			var y = openY + 0.06 * openH;
			var w = 0.22 * openH;
			var h = 0.22 * openH; 
			textFontSize = 0.20 * openH; 
			ctx.textBaseline = 'top';		
			ctx.textAlign = 'center';				
			ctx.font= textFontSize + "px HauracherellNC";
			textWidth = ctx.measureText(this.cityText[i]).width;
			var x = ig.global.game.center - textWidth/2 - (w + 0.02 * ig.global.game.width); 
			textX = ig.global.game.center;
			textY = openY + 0.08 * openH;
			
			/* City Text */
			ctx.fillStyle = "#1b6c91";
			ctx.fillText( this.cityText[i], textX, textY );	
			
			/* Flag */			 
			ctx.drawImage( this.levelFlag[i].data, x, y, w, h );

			/* Level Buttons */
			for(var j=0;j<=2;j++){
			
				h = 0.50 * openH;
				w = h;
				y = openY +  0.36 * openH;
				var yPressed = y + 0.1 * h;
				x =  ig.global.game.center - (0.03 * ig.global.game.width + 1.5 * w) + j * (0.03 * ig.global.game.width + w);
				if(ig.global.game.maxLevel >= 1 + 3 * i + j && click.x > x && click.x < x+w && click.y > y && click.y < y+h){y = yPressed;};
				
				/* Button */
				if(ig.global.game.maxLevel >= 1 + 3 * i + j){ctx.fillStyle = "#0e3f4b";}else{ctx.fillStyle = "#7a9298";}; 
				ig.auxiliar.radiusRectangle(ctx, x, yPressed , w, h, h/9, 1, 0);
				grd = ctx.createLinearGradient(x, y, x, y + h);
				grd.addColorStop(0,"#004167");
				grd.addColorStop(1,"#175c7b");		
				if(ig.global.game.maxLevel >= 1 + 3 * i + j){ctx.fillStyle = grd;}else{ctx.fillStyle = "#7f9fb0";}; 
				ig.auxiliar.radiusRectangle(ctx, x, y , w, h, h/9, 1, 0);

				/* Level Text */
				textFontSize = Math.round(0.64 * h); 
				textX = Math.round(x + 0.5 * w);
				textY = Math.round(y + 0.5 * h);
				ctx.fillStyle = "white";
				ctx.font= textFontSize + "px HauracherellNC";
				ctx.textBaseline = 'middle';		
				ctx.textAlign = 'center';	
				ctx.fillText( j + 1, textX, textY );					
				
			};
		
		};
			
		
		/* Topbar */
		grd = ctx.createLinearGradient(0,0,ig.global.game.width,ig.global.levelsMenuScreen.topBar.height);
		grd.addColorStop(0,"#006e91");
		grd.addColorStop(1,"#035d7a");
		ctx.fillStyle= grd;
		ctx.fillRect( ig.global.game.xmin, 0, ig.global.game.width, ig.global.levelsMenuScreen.topBar.height );
		
		/* Title */
		ctx.fillStyle = '#ffd51b';
		var textFontSize = ig.global.levelsMenuScreen.title.height;
		var textX = ig.global.levelsMenuScreen.title.x;
		var textY = ig.global.levelsMenuScreen.title.y;
		ctx.font= textFontSize + "px HauracherellNC";
		ctx.textBaseline = 'middle';		
		ctx.textAlign = 'left';	
		ctx.fillText( "Selección de Nivel", textX, textY );
		
		/* Home Button */
		ctx.fillStyle = "#d97609";	
		ig.auxiliar.radiusRectangle(ctx, ig.global.levelsMenuScreen.homeButton.x, ig.global.levelsMenuScreen.homeButton.pressedY , ig.global.levelsMenuScreen.homeButton.width, ig.global.levelsMenuScreen.homeButton.height, ig.global.levelsMenuScreen.homeButton.height/8, 1, 0);
		grd = ctx.createLinearGradient(ig.global.levelsMenuScreen.homeButton.x, ig.global.levelsMenuScreen.homeButton.y, ig.global.levelsMenuScreen.homeButton.x, ig.global.levelsMenuScreen.homeButton.y + ig.global.levelsMenuScreen.homeButton.height);
		grd.addColorStop(0,"#ffde00");
		grd.addColorStop(1,"#fea812");		
		ctx.fillStyle = grd;
		ig.auxiliar.radiusRectangle(ctx, ig.global.levelsMenuScreen.homeButton.x, ig.global.levelsMenuScreen.homeButton.y , ig.global.levelsMenuScreen.homeButton.width, ig.global.levelsMenuScreen.homeButton.height, ig.global.levelsMenuScreen.homeButton.height/8, 1, 0);
			/* Home Symbol */
			ctx.fillStyle = '#FFFFFF';
			var textFontSize = Math.floor(ig.global.levelsMenuScreen.homeButton.height * 0.5);
			var textX = ig.global.levelsMenuScreen.homeButton.x + Math.floor(ig.global.levelsMenuScreen.homeButton.width * 0.5);
			var textY = ig.global.levelsMenuScreen.homeButton.y + Math.floor(ig.global.levelsMenuScreen.homeButton.height * 0.5);	
			ctx.font= textFontSize + "px icomoon";
			ctx.textBaseline = 'middle';		
			ctx.textAlign = 'center';	
			ctx.fillText( "h", textX, textY );
	},
	
    update: function() {
	
		/* Back Button */ 
		ig.auxiliar.button(ig.global.levelsMenuScreen.homeButton);
		
		if( release.x >= ig.global.levelsMenuScreen.homeButton.x && release.x <= ig.global.levelsMenuScreen.homeButton.x + ig.global.levelsMenuScreen.homeButton.width &&  release.y >= ig.global.levelsMenuScreen.homeButton.y && release.y <= ig.global.levelsMenuScreen.homeButton.y + ig.global.levelsMenuScreen.homeButton.height ){
			ig.game.launchHome();
		};	
			
			
		if(this.startingDelay.delta() > 0){
				
			/* Button clicks */
			for(var i=0;i<=3;i++){
				var openH = ig.global.levelsMenuScreen.open.height;
				var openY = ig.global.levelsMenuScreen.open.scroll + i * openH;

				/* Level Buttons */
				for(var j=0;j<=2;j++){
				
					h = 0.50 * openH;
					w = h;
					y = openY +  0.36 * openH;
					var yPressed = y + 0.1 * h;
					x =  ig.global.game.center - (0.03 * ig.global.game.width + 1.5 * w) + j * (0.03 * ig.global.game.width + w);
					if(click.x > x && click.x < x+w && click.y > y && click.y < y+h){
						y = yPressed;
					};
					
					if(ig.global.game.maxLevel >= 1 + 3 * i + j && 
					lastClick.x > x && lastClick.x < x+w && lastClick.y > y && lastClick.y < y+h &&
					release.x > x && release.x < x+w && release.y > y && release.y < y+h
					){
						ig.global.game.open = 1 + i;
						ig.global.game.level = 1 + 3 * i + j;
						ig.game.launchLevel();
					};	
					
				};	
				
			};
			
			/* Scrolling */
			
			if(  click.y > 0 &&
				lastMouse.y > 0 &&
				ig.global.levelsMenuScreen.open.scroll >= 0 &&
				ig.global.levelsMenuScreen.open.scroll <= ig.global.levelsMenuScreen.topBar.height
			){	
			
				var scrollMove = Math.abs(mouse.y - lastMouse.y);
				
				/* Subir */
				if( mouse.y < lastMouse.y && ig.global.levelsMenuScreen.open.scroll - scrollMove >= 0 ){
					ig.global.levelsMenuScreen.open.scroll = ig.global.levelsMenuScreen.open.scroll - scrollMove;		
				}	
				
				/* Bajar */
				if( mouse.y > lastMouse.y && ig.global.levelsMenuScreen.open.scroll + scrollMove <= ig.global.levelsMenuScreen.topBar.height){
					ig.global.levelsMenuScreen.open.scroll = ig.global.levelsMenuScreen.open.scroll + scrollMove;		
				}		
			};		
		
			/* Level unlock cheat */
			var openH = ig.global.levelsMenuScreen.open.height;
			j = 0;
			h = 0.50 * openH;
			w = h;
							
			//USA I - FRA I
			x11 = ig.global.game.center - (0.03 * ig.global.game.width + 1.5 * w);
			y11 = ig.global.levelsMenuScreen.open.scroll + 3 * openH +  0.36 * openH;
			x12 = ig.global.game.center - (0.03 * ig.global.game.width + 1.5 * w);
			y12 = ig.global.levelsMenuScreen.open.scroll + 1 * openH +  0.36 * openH;		
			//FRA I - USA III
			x21 = ig.global.game.center - (0.03 * ig.global.game.width + 1.5 * w);
			y21 = ig.global.levelsMenuScreen.open.scroll + 1 * openH +  0.36 * openH;
			x22 = ig.global.game.center - (0.03 * ig.global.game.width + 1.5 * w) + 2 * (0.03 * ig.global.game.width + w);
			y22 = ig.global.levelsMenuScreen.open.scroll + 3 * openH +  0.36 * openH;
			//FRA I - USA III
			x31 = ig.global.game.center - (0.03 * ig.global.game.width + 1.5 * w) + 2 * (0.03 * ig.global.game.width + w);
			y31 = ig.global.levelsMenuScreen.open.scroll + 3 * openH +  0.36 * openH;
			x32 = ig.global.game.center - (0.03 * ig.global.game.width + 1.5 * w) + 2 * (0.03 * ig.global.game.width + w);
			y32 = ig.global.levelsMenuScreen.open.scroll + 1 * openH +  0.36 * openH;			
		
			if(
				lastClick.x > x11 && lastClick.x < x11 + w && lastClick.y > y11 && lastClick.y < y11 + h &&
				release.x > x12 && release.x < x12 + w && release.y > y12 && release.y < y12 + h
			){
				ig.global.game.cheat = 1;
			};	
			
			if(
				ig.global.game.cheat == 1 &&
				lastClick.x > x21 && lastClick.x < x21 + w && lastClick.y > y21 && lastClick.y < y21 + h &&
				release.x > x22 && release.x < x22 + w && release.y > y22 && release.y < y22 + h
			){
				ig.global.game.cheat = 2;
			};	

			if(
				ig.global.game.cheat == 2 &&
				lastClick.x > x31 && lastClick.x < x31 + w && lastClick.y > y31 && lastClick.y < y31 + h &&
				release.x > x32 && release.x < x32 + w && release.y > y32 && release.y < y32 + h
			){
				ig.global.game.maxLevel=12;
				ig.game.launchHome();
			};	

		};
		
		this.parent();
    }
   
});

});