ig.module(
   'game.entities.lostScreen'
)
.requires(
   'impact.entity'
)
.defines(function(){

EntityLostScreen = ig.Entity.extend({

   startingDelay : new ig.Timer(),

   collides: ig.Entity.COLLIDES.NEVER,

   nadalImage : new ig.Image( 'media/img/ui/lost/nadal.png' ),

   init: function( x, y, settings ) { 
	  clearMouse();
      this.startingDelay.set(2);
      this.parent( x, y, settings );
   },
   
   draw: function() {  
   
      this.parent();
      var ctx = ig.system.context;

      /* Plain Background */
      ctx.fillStyle= "#ffffff";
      ctx.fillRect( ig.global.game.xmin, 0, ig.global.game.width, ig.global.game.height );      
      
      /* Topbar */
      var grd = ctx.createLinearGradient(0,0,ig.global.game.width,ig.global.lostScreen.topBar.height);
      grd.addColorStop(0,"#006e91");
      grd.addColorStop(1,"#035d7a");
      ctx.fillStyle= grd;
      ctx.fillRect( ig.global.game.xmin, 0, ig.global.game.width, ig.global.lostScreen.topBar.height );
      
      /* Gradient Background */
      var grd = ctx.createLinearGradient(0,ig.global.lostScreen.gradient.y,0,ig.global.lostScreen.gradient.y + ig.global.lostScreen.gradient.height);
      grd.addColorStop(0,"#ffffff");
      grd.addColorStop(1,"#dcdcdc");
      ctx.fillStyle= grd;
      ctx.fillRect( ig.global.game.xmin, ig.global.lostScreen.gradient.y, ig.global.game.width, ig.global.lostScreen.gradient.height );   
      
      /* Title */
      ctx.fillStyle = '#ffd51b';
      var textFontSize = ig.global.lostScreen.title.height;
      var textX = ig.global.lostScreen.title.x;
      var textY = ig.global.lostScreen.title.y;
      ctx.font= textFontSize + "px HauracherellNC";
      ctx.textBaseline = 'middle';     
      ctx.textAlign = 'left'; 
      ctx.fillText( "¡Has perdido!", textX, textY );
              
      /* Image */
      ig.system.context.drawImage( this.nadalImage.data, ig.global.lostScreen.image.x, ig.global.lostScreen.image.y, ig.global.lostScreen.image.width, ig.global.lostScreen.image.height );

      /* Score text */
      ctx.fillStyle = '#1e6b95';
      var textFontSize = ig.global.lostScreen.score.height;
      var textX = ig.global.game.center;
      var textY = ig.global.lostScreen.score.y;
      ctx.font= textFontSize + "px HauracherellNC";
      ctx.textBaseline = 'top';     
      ctx.textAlign = 'center';  
      ctx.fillText( 'Puntuación: ' + ig.global.game.hits, textX, textY );      

      /* Bottombar */
      var grd = ctx.createLinearGradient(ig.global.game.xmin, ig.global.lostScreen.bottomBar.y, ig.global.game.xmin, ig.global.lostScreen.bottomBar.y + ig.global.lostScreen.bottomBar.height);
      grd.addColorStop(0,"#006e91");
      grd.addColorStop(1,"#035d7a");
      ctx.fillStyle= grd;
      ctx.fillRect( ig.global.game.xmin, ig.global.lostScreen.bottomBar.y, ig.global.game.width, ig.global.lostScreen.bottomBar.height );    
      
      if(this.startingDelay.delta() < 0){
         var d = ig.global.tutorialScreen.easingTime;
         moveY = ig.global.lostScreen.playAgainButton.y + 0.1 * ig.global.game.height * (1 - (ig.auxiliar.outExpo(1 - Math.abs(this.startingDelay.delta()))));
         pressedY = ig.global.lostScreen.playAgainButton.pressedY + 0.1 * ig.global.game.height * (1 - (ig.auxiliar.outExpo(1 - Math.abs(this.startingDelay.delta()))));
      }else{
         moveY = ig.global.lostScreen.playAgainButton.y;
         pressedY = ig.global.lostScreen.playAgainButton.pressedY;
      };
      
      /* Play Again Button */
      ctx.fillStyle = "#d47800"; 
      ig.auxiliar.radiusRectangle(ctx, ig.global.lostScreen.playAgainButton.x, pressedY, ig.global.lostScreen.playAgainButton.width, ig.global.lostScreen.playAgainButton.height, ig.global.lostScreen.playAgainButton.height/8, 1, 0);
      grd = ctx.createLinearGradient(ig.global.lostScreen.playAgainButton.x, moveY, ig.global.lostScreen.playAgainButton.x, moveY + ig.global.lostScreen.playAgainButton.height);
      grd.addColorStop(0,"#ffde00");
      grd.addColorStop(1,"#fea812");      
      ctx.fillStyle = grd;
      ig.auxiliar.radiusRectangle(ctx, ig.global.lostScreen.playAgainButton.x, moveY , ig.global.lostScreen.playAgainButton.width, ig.global.lostScreen.playAgainButton.height, ig.global.lostScreen.playAgainButton.height/8, 1, 0);
      var textFontSize = Math.floor(ig.global.lostScreen.playAgainButton.height * 0.7);
      var textX = ig.global.lostScreen.playAgainButton.x + Math.floor(ig.global.lostScreen.playAgainButton.width * 0.5);
      var textY = moveY + Math.floor(ig.global.lostScreen.playAgainButton.height * 0.55);
      ctx.fillStyle = '#FFFFFF';
      ctx.font= textFontSize + "px HauracherellNC";
      ctx.textBaseline = 'middle';        
      ctx.textAlign = 'center';     
      ctx.fillText( "VOLVER A JUGAR", textX, textY );   

      /* Exit Button */
      ctx.fillStyle = "#d97609"; 
      ig.auxiliar.radiusRectangle(ctx, ig.global.lostScreen.homeButton.x, ig.global.lostScreen.homeButton.pressedY , ig.global.lostScreen.homeButton.width, ig.global.lostScreen.homeButton.height, ig.global.lostScreen.homeButton.height/8, 1, 0);
      grd = ctx.createLinearGradient(ig.global.lostScreen.homeButton.x, ig.global.lostScreen.homeButton.y, ig.global.lostScreen.homeButton.x, ig.global.lostScreen.homeButton.y + ig.global.lostScreen.homeButton.height);
      grd.addColorStop(0,"#ffde00");
      grd.addColorStop(1,"#fea812");      
      ctx.fillStyle = grd;
      ig.auxiliar.radiusRectangle(ctx, ig.global.lostScreen.homeButton.x, ig.global.lostScreen.homeButton.y , ig.global.lostScreen.homeButton.width, ig.global.lostScreen.homeButton.height, ig.global.lostScreen.homeButton.height/8, 1, 0);
        /* Exit Symbol */
         ctx.fillStyle = '#FFFFFF';
         var textFontSize = Math.floor(ig.global.lostScreen.homeButton.height * 0.8);
         var textX = ig.global.lostScreen.homeButton.x + Math.floor(ig.global.lostScreen.homeButton.width * 0.5);
         var textY = ig.global.lostScreen.homeButton.y + Math.floor(ig.global.lostScreen.homeButton.height * 0.5);   
         ctx.font= textFontSize + "px icomoon";
         ctx.textBaseline = 'middle';     
         ctx.textAlign = 'center';  
         ctx.fillText( "q", textX, textY );
      
   },
   
    update: function() {

      /* Exit Button */
		ig.auxiliar.button(ig.global.lostScreen.homeButton);

		if( release.x >= ig.global.lostScreen.homeButton.x && release.x <= ig.global.lostScreen.homeButton.x + ig.global.lostScreen.homeButton.width &&  release.y >= ig.global.lostScreen.homeButton.y && release.y <= ig.global.lostScreen.homeButton.y + ig.global.lostScreen.homeButton.height ){
			clearMouse();
			ig.game.exit();
		};

	
      if(this.startingDelay.delta()>0){
      
         /* Play Again Button */
         ig.auxiliar.button(ig.global.lostScreen.playAgainButton);
         
         if( 
			release.x >= ig.global.lostScreen.playAgainButton.x && release.x <= ig.global.lostScreen.playAgainButton.x + ig.global.lostScreen.playAgainButton.width &&  release.y >= ig.global.lostScreen.playAgainButton.y && release.y <= ig.global.lostScreen.playAgainButton.y + ig.global.lostScreen.playAgainButton.height &&
			lastClick.x >= ig.global.lostScreen.playAgainButton.x && lastClick.x <= ig.global.lostScreen.playAgainButton.x + ig.global.lostScreen.playAgainButton.width &&  lastClick.y >= ig.global.lostScreen.playAgainButton.y && lastClick.y <= ig.global.lostScreen.playAgainButton.y + ig.global.lostScreen.playAgainButton.height
		 ){
			clearMouse();
			ig.game.saveLastGameDate();
			ig.game.launchGame();
         };    
      
      };
      
      this.parent();
    }
   
});

});
