ig.module(
	'game.entities.pauseScreen'
)
.requires(
	'impact.entity'
)
.defines(function(){

EntityPauseScreen = ig.Entity.extend({

	collides: ig.Entity.COLLIDES.NEVER,

	init: function( x, y, settings ) {
		clearMouse();
		this.parent(x, y, settings);
	},
	
	draw: function() {  
		this.parent();
		var ctx = ig.system.context;

		/* Plain Background */
		ctx.fillStyle= "#000000";
		ctx.globalAlpha=0.7;
		ctx.fillRect( ig.global.game.xmin, 0, ig.global.game.width, ig.global.game.height );		
		ctx.globalAlpha=1;
		
		/* Continue Button */
		ctx.fillStyle = "#034462";	
		ig.auxiliar.radiusRectangle(ctx, ig.global.pauseScreen.continueButton.x, ig.global.pauseScreen.continueButton.pressedY , ig.global.pauseScreen.continueButton.width, ig.global.pauseScreen.continueButton.height, ig.global.pauseScreen.continueButton.height/8, 1, 0);
		var grd = ctx.createLinearGradient(ig.global.pauseScreen.continueButton.x,ig.global.pauseScreen.continueButton.y,ig.global.pauseScreen.continueButton.x,ig.global.pauseScreen.continueButton.y + ig.global.pauseScreen.continueButton.height);
		grd.addColorStop(0,"#006282");
		grd.addColorStop(1,"#008598");		
		ctx.fillStyle = grd;
		ig.auxiliar.radiusRectangle(ctx, ig.global.pauseScreen.continueButton.x, ig.global.pauseScreen.continueButton.y , ig.global.pauseScreen.continueButton.width, ig.global.pauseScreen.continueButton.height, ig.global.pauseScreen.continueButton.height/8, 1, 0);
		var textFontSize = Math.floor(ig.global.pauseScreen.continueButton.height * 0.8);
		var textX = ig.global.pauseScreen.continueButton.x + Math.floor(ig.global.pauseScreen.continueButton.width * 0.5);
		var textY = ig.global.pauseScreen.continueButton.y + Math.floor(ig.global.pauseScreen.continueButton.height * 0.55);
		ctx.fillStyle = '#FFFFFF';
		ctx.font= textFontSize + "px HauracherellNC";
		ctx.textBaseline = 'middle';			
		ctx.textAlign = 'center';		
		ctx.fillText( "CONTINUAR", textX, textY );
		/* Continue Symbol */
		ctx.fillStyle = '#FFFFFF';
		var textFontSize = Math.floor(ig.global.pauseScreen.continueButton.height * 0.8);
		var textX = ig.global.pauseScreen.continueButton.x + Math.floor(ig.global.pauseScreen.continueButton.width * 0.062);
		var textY = ig.global.pauseScreen.continueButton.y + Math.floor(ig.global.pauseScreen.continueButton.height * 0.5);	
		ctx.font= textFontSize + "px icomoon";
		ctx.textBaseline = 'middle';		
		ctx.textAlign = 'center';	
		ctx.fillText( "p", textX, textY );	
		
		/* Exit Button */
		ctx.fillStyle = "#d47800";	
		ig.auxiliar.radiusRectangle(ctx, ig.global.pauseScreen.exitButton.x, ig.global.pauseScreen.exitButton.pressedY , ig.global.pauseScreen.exitButton.width, ig.global.pauseScreen.exitButton.height, ig.global.pauseScreen.exitButton.height/8, 1, 0);
		var grd = ctx.createLinearGradient(ig.global.pauseScreen.exitButton.x,ig.global.pauseScreen.exitButton.y,ig.global.pauseScreen.exitButton.x,ig.global.pauseScreen.exitButton.y + ig.global.pauseScreen.exitButton.height);
		grd.addColorStop(0,"#ffde00");
		grd.addColorStop(1,"#fea812");		
		ctx.fillStyle = grd;
		ig.auxiliar.radiusRectangle(ctx, ig.global.pauseScreen.exitButton.x, ig.global.pauseScreen.exitButton.y , ig.global.pauseScreen.exitButton.width, ig.global.pauseScreen.exitButton.height, ig.global.pauseScreen.exitButton.height/8, 1, 0);
		var textFontSize = Math.floor(ig.global.pauseScreen.exitButton.height*0.8);
		var textX = ig.global.pauseScreen.exitButton.x + Math.floor(ig.global.pauseScreen.exitButton.width * 0.5);
		var textY = ig.global.pauseScreen.exitButton.y + Math.floor(ig.global.pauseScreen.exitButton.height * 0.55);
		ctx.fillStyle = '#FFFFFF';
		ctx.font= textFontSize + "px HauracherellNC";
		ctx.textBaseline = 'middle';			
		ctx.textAlign = 'center';		
		ctx.fillText( "SALIR DEL JUEGO", textX, textY );
		/* Continue Symbol */
		ctx.fillStyle = '#FFFFFF';
		var textFontSize = Math.floor(ig.global.pauseScreen.exitButton.height * 0.8);
		var textX = ig.global.pauseScreen.exitButton.x + Math.floor(ig.global.pauseScreen.exitButton.width * 0.062);
		var textY = ig.global.pauseScreen.exitButton.y + Math.floor(ig.global.pauseScreen.exitButton.height * 0.5);	
		ctx.font= textFontSize + "px icomoon";
		ctx.textBaseline = 'middle';		
		ctx.textAlign = 'center';	
		ctx.fillText( "e", textX, textY );			

		/* Sound Button */
		ctx.fillStyle = "#d97609";	
		ig.auxiliar.radiusRectangle(ctx, ig.global.pauseScreen.soundButton.x, ig.global.pauseScreen.soundButton.pressedY , ig.global.pauseScreen.soundButton.width, ig.global.pauseScreen.soundButton.height, ig.global.pauseScreen.soundButton.height/8, 1, 0);
		grd = ctx.createLinearGradient(ig.global.pauseScreen.soundButton.x, ig.global.pauseScreen.soundButton.y, ig.global.pauseScreen.soundButton.x, ig.global.pauseScreen.soundButton.y + ig.global.pauseScreen.soundButton.height);
		grd.addColorStop(0,"#ffde00");
		grd.addColorStop(1,"#fea812");		
		ctx.fillStyle = grd;
		ig.auxiliar.radiusRectangle(ctx, ig.global.pauseScreen.soundButton.x, ig.global.pauseScreen.soundButton.y , ig.global.pauseScreen.soundButton.width, ig.global.pauseScreen.soundButton.height, ig.global.pauseScreen.soundButton.height/8, 1, 0);
			/* Exit Symbol */
			ctx.fillStyle = '#FFFFFF';
			var textFontSize = Math.floor(ig.global.pauseScreen.soundButton.height * 0.8);
			var textX = ig.global.pauseScreen.soundButton.x + Math.floor(ig.global.pauseScreen.soundButton.width * 0.5);
			var textY = ig.global.pauseScreen.soundButton.y + Math.floor(ig.global.pauseScreen.soundButton.height * 0.5);	
			ctx.font= textFontSize + "px icomoon";
			ctx.textBaseline = 'middle';		
			ctx.textAlign = 'center';	
			if(window.config.sound == 1){
				ctx.fillText( "o", textX, textY );
			}else{
				ctx.fillText( "f", textX, textY );
			};
		
	},
	
    update: function() {
		 
		if(ig.global.game.paused == 1){
			/* Continue Button */ 
			ig.auxiliar.button(ig.global.pauseScreen.continueButton);
			
			if( 
				lastClick.x >= ig.global.pauseScreen.continueButton.x && lastClick.x <= ig.global.pauseScreen.continueButton.x + ig.global.pauseScreen.continueButton.width &&  lastClick.y >= ig.global.pauseScreen.continueButton.y && lastClick.y <= ig.global.pauseScreen.continueButton.y + ig.global.pauseScreen.continueButton.height &&
				release.x >= ig.global.pauseScreen.continueButton.x && release.x <= ig.global.pauseScreen.continueButton.x + ig.global.pauseScreen.continueButton.width &&  release.y >= ig.global.pauseScreen.continueButton.y && release.y <= ig.global.pauseScreen.continueButton.y + ig.global.pauseScreen.continueButton.height
			){
				ig.game.continueGame();
			};	

			/* Exit Button */ 
			ig.auxiliar.button(ig.global.pauseScreen.exitButton);
			
			if( 
				lastClick.x >= ig.global.pauseScreen.exitButton.x && lastClick.x <= ig.global.pauseScreen.exitButton.x + ig.global.pauseScreen.exitButton.width &&  lastClick.y >= ig.global.pauseScreen.exitButton.y && lastClick.y <= ig.global.pauseScreen.exitButton.y + ig.global.pauseScreen.exitButton.height &&
				release.x >= ig.global.pauseScreen.exitButton.x && release.x <= ig.global.pauseScreen.exitButton.x + ig.global.pauseScreen.exitButton.width &&  release.y >= ig.global.pauseScreen.exitButton.y && release.y <= ig.global.pauseScreen.exitButton.y + ig.global.pauseScreen.exitButton.height
			){
				ig.game.exitPausedGame();
			};		
		};	
		
		if(ig.Sound.enabled = true){

			/* Sound Button */ 
			ig.auxiliar.button(ig.global.pauseScreen.soundButton);		

			if( 
				lastClick.x >= ig.global.pauseScreen.soundButton.x && lastClick.x <= ig.global.pauseScreen.soundButton.x + ig.global.pauseScreen.soundButton.width &&  lastClick.y >= ig.global.pauseScreen.soundButton.y && lastClick.y <= ig.global.pauseScreen.soundButton.y + ig.global.pauseScreen.soundButton.height &&
				release.x >= ig.global.pauseScreen.soundButton.x && release.x <= ig.global.pauseScreen.soundButton.x + ig.global.pauseScreen.soundButton.width &&  release.y >= ig.global.pauseScreen.soundButton.y && release.y <= ig.global.pauseScreen.soundButton.y + ig.global.pauseScreen.soundButton.height
			){
				if(window.config.sound==1){
					ig.game.disableSound();
				}else{
					ig.game.enableSound();
				}
				clearMouse();
			}						
		
		}	
				
		this.parent();
    }	
   
});

});