ig.module(
	'game.entities.player'
)
.requires(
	'impact.entity'
)
.defines(function(){

EntityPlayer = ig.Entity.extend({
	
	animSheet: new ig.AnimationSheet( 'media/img/game/player.png', 230, 200 ),
	
	size: {x: 230, y: 200},
	 
	collides: ig.Entity.COLLIDES.NEVER,
	
	init: function( x, y, settings ) {
		clearMouse();
		this.parent(x, y, settings);
		this.setScale(ig.global.player.width/230,ig.global.player.height/200);
		this.pos.x = ig.global.game.center - ig.global.player.width/2;
		this.pos.y = ig.global.player.y;
		this.addAnim( 'left', 1, [0] );
		this.addAnim( 'right', 1, [1], true );
	},

    update: function() {

		if(this.pos.x < (ig.system.width/2 - this.size.x/2)){
			this.currentAnim = this.anims.right;
		}else{
			this.currentAnim = this.anims.left;
		}
   
		if( 
			ig.global.game.paused == 0 && 
			ig.game.getEntityByName('ball').lostDelay.delta() == 0 && 
			click.x > 0 && click.y > 0 && mouse.x <= ig.global.game.xmax && mouse.x >= ig.global.game.xmin && mouse.y >= ig.global.pitch.y
		) {
			
			if(mouse.x >= ig.global.game.xmax - this.size.x){mouse.x = ig.global.game.xmax - this.size.x;};
			
			if(ig.global.game.life > 0){ 
				ig.global.game.life = ig.global.game.life - ( Math.abs(mouse.x - this.pos.x) / ig.global.game.width * 8 ); 
			}else{
				ig.global.game.life = 0
			};
			
			if(this.pos.x > mouse.x){
				this.pos.x = this.pos.x - Math.abs(this.pos.x - mouse.x) * (0.95 * ig.global.game.life/ig.global.game.maxLife + 0.05);
			}else{
				this.pos.x = this.pos.x + Math.abs(this.pos.x - mouse.x) * (0.95 * ig.global.game.life/ig.global.game.maxLife + 0.05);
			}
		};
      
      this.parent();
   }	
});

});