ig.module(
	'game.entities.topBar'
)
.requires(
	'impact.entity'
)
.defines(function(){

EntityTopBar = ig.Entity.extend({ 
		
	collides: ig.Entity.COLLIDES.NEVER,

	init: function( x, y, settings ) {
		clearMouse();
		this.parent(x, y, settings);
	},
	
    draw: function() {  
        this.parent();
		var ctx = ig.system.context;	

		/* Background gradient */
		var grd = ctx.createLinearGradient(0,0,0, ig.global.topBar.height);
		grd.addColorStop(0,"#006e90");
		grd.addColorStop(1,"#025b78");
		ctx.fillStyle= grd;
		ctx.fillRect( ig.global.game.xmin, 0, ig.global.topBar.width, ig.global.topBar.height  );
		
		/* Pause Button */
			/* Real Layer */
			ctx.fillStyle = '#d97609';
			ig.auxiliar.radiusRectangle(ctx, ig.global.pauseButton.x, ig.global.pauseButton.pressedY, ig.global.pauseButton.width, ig.global.pauseButton.height, ig.global.pauseButton.height/8, 1, 0);
			/* Front layer */
			var grd = ctx.createLinearGradient(0,0,0, ig.global.pauseButton.height);
			grd.addColorStop(0.5,"#ffda1c");
			grd.addColorStop(1,"#fea913");		
			ctx.fillStyle = grd;
			ig.auxiliar.radiusRectangle(ctx, ig.global.pauseButton.x, ig.global.pauseButton.y , ig.global.pauseButton.width, ig.global.pauseButton.height, ig.global.pauseButton.height/8, 1, 0);
			/* Pause Symbol */
			ctx.fillStyle = '#FFFFFF';
			var textFontSize = Math.floor(ig.global.pauseButton.height*0.8);
			var textX = ig.global.pauseButton.x + Math.floor(ig.global.pauseButton.width * 0.5);
			var textY = ig.global.pauseButton.y + Math.floor(ig.global.pauseButton.height * 0.5);	
			ctx.font= textFontSize + "px icomoon";
			ctx.textBaseline = 'middle';		
			ctx.textAlign = 'center';	
			ctx.fillText( "s", textX, textY );			
		
		
		/* Life bar */
		ctx.fillStyle = '#02485f';		
		ig.auxiliar.radiusRectangle(ctx, ig.global.game.lifeBar.x, ig.global.game.lifeBar.y, ig.global.game.lifeBar.width, ig.global.game.lifeBar.height, ig.global.game.lifeBar.height/8, 1, 0);
		
		var barX = ig.global.game.lifeBar.x + ig.global.game.lifeBar.width * 0.02;
		var barY = ig.global.game.lifeBar.y + ig.global.game.lifeBar.height * 0.1;
		var barWidth = ig.global.game.lifeBar.width * 0.96;
		var barHeight = ig.global.game.lifeBar.height * 0.8;
		
		
			/* Background */
			ctx.fillStyle = '#ec541c';
			ig.auxiliar.radiusRectangle(ctx, barX, barY, barWidth, barHeight, ig.global.game.lifeBar.height/8, 1, 0);			
			/* Life */
			if(ig.global.game.life > 0){
				ctx.fillStyle = '#fadf1d';
				ig.auxiliar.radiusRectangle(ctx, barX, barY, barWidth * ig.global.game.life/ig.global.game.maxLife, barHeight, ig.global.game.lifeBar.height/8, 1, 0);
			}
			ctx.fillStyle = 'white';
			ctx.globalAlpha=0.7;
			ig.auxiliar.radiusRectangle(ctx, barX + barWidth * 0.05, barY + barHeight * 0.25, barWidth * 0.9, barHeight * 0.12 , ig.global.game.lifeBar.height/20, 1, 0);				
			ctx.globalAlpha=1;
		
		/* Score text */
		ctx.fillStyle = '#02485f';		
		ig.auxiliar.radiusRectangle(ctx, ig.global.score.x, ig.global.score.y, ig.global.score.width, ig.global.score.height, ig.global.score.height/8, 1, 0);
		ctx.fillStyle = '#366372';
		ctx.fillRect( ig.global.score.x + ig.global.score.width/2 , ig.global.score.y, 1, ig.global.score.height );
	
			var text, textX, textY;
			var textFontSize = Math.floor(ig.global.score.height*0.8);

			/* Actual hits */
			if(ig.global.game.hits < 10){
				var text = '0' + ig.global.game.hits;
			}else{
				var text = ig.global.game.hits;
			}
			textX = ig.global.score.x + Math.round(ig.global.score.width * 0.25);
			textY = ig.global.score.y + Math.round(ig.global.score.height * 0.50);
			ctx.fillStyle = '#FFFFFF';
			ctx.font= textFontSize + "px HauracherellNC";
			ctx.textBaseline = 'middle';		
			ctx.textAlign = 'center';			
			ctx.fillText( text, textX, textY );
			
			/* Hit target */
			if(ig.global.game.maxHits < 10){
				text = '0' + ig.global.game.maxHits;
			}else{
				text = ig.global.game.maxHits;
			}			
			textX = ig.global.score.x + Math.round(ig.global.score.width * 0.75);
			textY = ig.global.score.y + Math.round(ig.global.score.height * 0.50);
			ctx.fillStyle = '#7accd1';
			ctx.font= textFontSize + "px HauracherellNC";
			ctx.textBaseline = 'middle';	
			ctx.textAlign = 'center';				
			ctx.fillText( text, textX, textY );
		
    },
	
	
    update: function() {
		 
		if( ig.global.game.paused == 0 ){
			ig.auxiliar.button(ig.global.pauseButton);
			if( release.x >= ig.global.pauseButton.x && release.x <= ig.global.pauseButton.x + ig.global.pauseButton.width &&  release.y >= ig.global.pauseButton.y && release.y <= ig.global.pauseButton.y + ig.global.pauseButton.height ){
				ig.game.pauseGame();
				clearMouse();
			};
		};

		this.parent();
    }	
  
});

});