ig.module(
	'game.entities.tutorialScreen'
)
.requires(
	'impact.entity'
)
.defines(function(){

EntityTutorialScreen = ig.Entity.extend({

	collides: ig.Entity.COLLIDES.NEVER,
	
	durationTimer : new ig.Timer(),

	tutorialImage : [
		new ig.Image( 'media/img/ui/tutorial/01.png' ),
		new ig.Image( 'media/img/ui/tutorial/02.png' ),
		new ig.Image( 'media/img/ui/tutorial/03.png' ),
		new ig.Image( 'media/img/ui/tutorial/04.png' ),
		new ig.Image( 'media/img/ui/tutorial/05.png' )
	],

	init: function( x, y, settings ) {
		this.durationTimer.set(ig.global.tutorialScreen.easingTime);
		clearMouse();
		this.parent(x, y, settings);
	},
	
	draw: function() {  
	
		this.parent();
		var ctx = ig.system.context;

		/* Plain Background */
		ctx.fillStyle= "#ffffff";
		ctx.fillRect( ig.global.game.xmin, 0, ig.global.game.width, ig.global.game.height );		
		
		/* Topbar */
		var grd = ctx.createLinearGradient(0,0,ig.global.game.width,ig.global.tutorialScreen.topBar.height);
		grd.addColorStop(0,"#006e91");
		grd.addColorStop(1,"#035d7a");
		ctx.fillStyle= grd;
		ctx.fillRect( ig.global.game.xmin, 0, ig.global.game.width, ig.global.tutorialScreen.topBar.height );
		
		/* Title */
		ctx.fillStyle = '#ffd51b';
		var textFontSize = ig.global.tutorialScreen.title.height;
		var textX = ig.global.tutorialScreen.title.x;
		var textY = ig.global.tutorialScreen.title.y;
		ctx.font= textFontSize + "px HauracherellNC";
		ctx.textBaseline = 'middle';		
		ctx.textAlign = 'left';	
		ctx.fillText( "Tutorial", textX, textY );
		
		/* Home Button */
		ctx.fillStyle = "#d97609";	
		ig.auxiliar.radiusRectangle(ctx, ig.global.tutorialScreen.homeButton.x, ig.global.tutorialScreen.homeButton.pressedY , ig.global.tutorialScreen.homeButton.width, ig.global.tutorialScreen.homeButton.height, ig.global.tutorialScreen.homeButton.height/8, 1, 0);
		grd = ctx.createLinearGradient(ig.global.tutorialScreen.homeButton.x, ig.global.tutorialScreen.homeButton.y, ig.global.tutorialScreen.homeButton.x, ig.global.tutorialScreen.homeButton.y + ig.global.tutorialScreen.homeButton.height);
		grd.addColorStop(0,"#ffde00");
		grd.addColorStop(1,"#fea812");		
		ctx.fillStyle = grd;
		ig.auxiliar.radiusRectangle(ctx, ig.global.tutorialScreen.homeButton.x, ig.global.tutorialScreen.homeButton.y , ig.global.tutorialScreen.homeButton.width, ig.global.tutorialScreen.homeButton.height, ig.global.tutorialScreen.homeButton.height/8, 1, 0);
			/* Exit Symbol */
			ctx.fillStyle = '#FFFFFF';
			var textFontSize = Math.floor(ig.global.tutorialScreen.homeButton.height * 0.5);
			var textX = ig.global.tutorialScreen.homeButton.x + Math.floor(ig.global.tutorialScreen.homeButton.width * 0.5);
			var textY = ig.global.tutorialScreen.homeButton.y + Math.floor(ig.global.tutorialScreen.homeButton.height * 0.5);	
			ctx.font= textFontSize + "px icomoon";
			ctx.textBaseline = 'middle';		
			ctx.textAlign = 'center';	
			ctx.fillText( "h", textX, textY );
			
		/* Image Area */
		var grd = ctx.createLinearGradient(0,ig.global.tutorialScreen.imageArea.y,0,ig.global.tutorialScreen.imageArea.y + ig.global.tutorialScreen.imageArea.height);
		grd.addColorStop(0,"#ffffff");
		grd.addColorStop(1,"#dbdbdb");
		ctx.fillStyle= grd;
		ctx.fillRect( ig.global.game.xmin, ig.global.tutorialScreen.imageArea.y, ig.global.game.width, ig.global.tutorialScreen.imageArea.height );		
		
		
			/* Image */
			if(this.durationTimer.delta() < 0){ 
				ig.system.context.globalAlpha = ig.auxiliar.outExpo(1 - Math.abs(this.durationTimer.delta())/ig.global.tutorialScreen.easingTime)
				var moveY = ig.global.tutorialScreen.image.y - 0.05 * ig.global.game.height * (1 - ig.auxiliar.outExpo(1 - Math.abs(this.durationTimer.delta())/ig.global.tutorialScreen.easingTime));	
			}else{
				var moveY = ig.global.tutorialScreen.image.y;
			}			
			ig.system.context.drawImage( this.tutorialImage[ig.global.tutorialScreen.activeTutorial - 1].data, ig.global.tutorialScreen.image.x, moveY, ig.global.tutorialScreen.image.width, ig.global.tutorialScreen.image.height );
			ig.system.context.globalAlpha = 1;
		
		/* Bubble + Text */
		if(this.durationTimer.delta() < 0){ 
			ig.system.context.globalAlpha = ig.auxiliar.outExpo(1 - Math.abs(this.durationTimer.delta())/ig.global.tutorialScreen.easingTime)
			var moveY = ig.global.tutorialScreen.bubble.y + 0.05 * ig.global.game.height * (1 - ig.auxiliar.outExpo(1 - Math.abs(this.durationTimer.delta())/ig.global.tutorialScreen.easingTime));	
		}else{
			var moveY = ig.global.tutorialScreen.bubble.y;
		}			
		ctx.fillStyle = '#006e91';
		ig.auxiliar.radiusRectangle(ctx, ig.global.tutorialScreen.bubble.x, moveY , ig.global.tutorialScreen.bubble.width, ig.global.tutorialScreen.bubble.height, ig.global.tutorialScreen.bubble.height/50, 1, 0);
		//Bubble Triangle
		ctx.moveTo(ig.global.tutorialScreen.bubbleTriangle.x1, moveY);
		ctx.lineTo(ig.global.tutorialScreen.bubbleTriangle.xc, moveY - ig.global.tutorialScreen.bubbleTriangle.height);
		ctx.lineTo(ig.global.tutorialScreen.bubbleTriangle.x2, moveY);
		ctx.lineTo(ig.global.tutorialScreen.bubbleTriangle.x1, moveY);		
		ctx.fill();
		//Text
		ctx.fillStyle = '#FFFFFF';
		switch(ig.global.tutorialScreen.activeTutorial){
			case 1 : ig.auxiliar.tutorialText(ctx,4,'Jugando como Nadal, deberás devolver','el mayor número de pelotas, sin perder.','Cuantas más pelotas devueltas, mayor','puntuación obtendrás.',moveY);break;
			case 2 : ig.auxiliar.tutorialText(ctx,4,' ','Mueve tu jugador de derecha a','izquierda para golpear la pelota de tenis.',' ',moveY);break;		
			case 3 : ig.auxiliar.tutorialText(ctx,3,'Tu oponente lanzará bolas de fuego,', 'hielo y metal que deberás esquivar si no','quieres que te eliminen.','',moveY);break;
			case 4 : ig.auxiliar.tutorialText(ctx,4,'Observa la barra de energía, te', 'moverás ágilmente o con mayor', 'lentitud, captura el avituallamiento para', 'recuperar el máximo de energía.',moveY);break;
			case 5 : ig.auxiliar.tutorialText(ctx,3,'A veces el público te lanzará objetos', 'para distraerte, ¡mantén la','concentración!','',moveY);break;
		};	
		
		ig.system.context.globalAlpha = 1;

		/* Pagination text */
		ctx.fillStyle = '#006e91';
		var textFontSize = ig.global.tutorialScreen.pagination.height;
		var textX = ig.global.game.center;
		var textY = ig.global.tutorialScreen.pagination.y;
		ctx.font= textFontSize + "px HauracherellNC";
		ctx.textBaseline = 'top';		
		ctx.textAlign = 'center';	
		ctx.fillText( ig.global.tutorialScreen.activeTutorial + "/" + ig.global.tutorialScreen.pages, textX, textY );
		
		/* Pagination balls */
		for(i = 1; i <= ig.global.tutorialScreen.pages; i++){
			ctx.beginPath();
			if(ig.global.tutorialScreen.activeTutorial == i){ctx.fillStyle = '#006e91';}else{ctx.fillStyle = '#a1d1e4';};
			var ballX = ig.global.tutorialScreen.balls.x + (i-1) * (2 * ig.global.tutorialScreen.balls.radius + ig.global.tutorialScreen.balls.margin);
			ctx.arc(ballX, ig.global.tutorialScreen.balls.y, ig.global.tutorialScreen.balls.radius, 0, 2 * Math.PI, false);
			ctx.fill();	
		}
		
		/* Previous button */
		if(ig.global.tutorialScreen.activeTutorial > 1){ctx.fillStyle = '#006e91';}else{ctx.fillStyle = '#a1d1e4';};
		var textFontSize = ig.global.tutorialScreen.previousButton.height;
		var textX = ig.global.tutorialScreen.previousButton.x + ig.global.tutorialScreen.previousButton.width/2;
		var textY = ig.global.tutorialScreen.previousButton.y;
		ctx.font= textFontSize + "px HauracherellNC";
		ctx.textBaseline = 'top';		
		ctx.textAlign = 'center';	
		ctx.fillText( "<", textX, textY );		
		
		/* Next button */
		if(ig.global.tutorialScreen.activeTutorial < ig.global.tutorialScreen.pages){ctx.fillStyle = '#006e91';}else{ctx.fillStyle = '#a1d1e4';};
		var textFontSize = ig.global.tutorialScreen.nextButton.height;
		var textX = ig.global.tutorialScreen.nextButton.x + ig.global.tutorialScreen.nextButton.width/2;
		var textY = ig.global.tutorialScreen.nextButton.y;
		ctx.font= textFontSize + "px HauracherellNC";
		ctx.textBaseline = 'top';		
		ctx.textAlign = 'center';	
		ctx.fillText( ">", textX, textY );			
		
	},
	
    update: function() {

		/* Home Button */ 
		ig.auxiliar.button(ig.global.tutorialScreen.homeButton);
		
		if( release.x >= ig.global.tutorialScreen.homeButton.x && release.x <= ig.global.tutorialScreen.homeButton.x + ig.global.tutorialScreen.homeButton.width &&  release.y >= ig.global.tutorialScreen.homeButton.y && release.y <= ig.global.tutorialScreen.homeButton.y + ig.global.tutorialScreen.homeButton.height ){
			clearMouse();
			ig.game.launchHome();
		};		
		
		/* Previous Button */
		if( 
		lastClick.x >= ig.global.tutorialScreen.previousButton.x && lastClick.x <= ig.global.tutorialScreen.previousButton.x + ig.global.tutorialScreen.previousButton.width &&  lastClick.y >= ig.global.tutorialScreen.previousButton.y && lastClick.y <= ig.global.tutorialScreen.previousButton.y + ig.global.tutorialScreen.previousButton.height &&
		release.x >= ig.global.tutorialScreen.previousButton.x && release.x <= ig.global.tutorialScreen.previousButton.x + ig.global.tutorialScreen.previousButton.width &&  release.y >= ig.global.tutorialScreen.previousButton.y && release.y <= ig.global.tutorialScreen.previousButton.y + ig.global.tutorialScreen.previousButton.height 
		){
			if(ig.global.tutorialScreen.activeTutorial > 1){ig.global.tutorialScreen.activeTutorial--; this.durationTimer.set(ig.global.tutorialScreen.easingTime);};
			clearMouse();	
		};
		
		/* Next Button */
		if( 
		lastClick.x >= ig.global.tutorialScreen.nextButton.x && lastClick.x <= ig.global.tutorialScreen.nextButton.x + ig.global.tutorialScreen.nextButton.width && lastClick.y >= ig.global.tutorialScreen.nextButton.y && lastClick.y <= ig.global.tutorialScreen.nextButton.y + ig.global.tutorialScreen.nextButton.height  &&
		release.x >= ig.global.tutorialScreen.nextButton.x && release.x <= ig.global.tutorialScreen.nextButton.x + ig.global.tutorialScreen.nextButton.width && release.y >= ig.global.tutorialScreen.nextButton.y && release.y <= ig.global.tutorialScreen.nextButton.y + ig.global.tutorialScreen.nextButton.height 
		){
			if(ig.global.tutorialScreen.activeTutorial < ig.global.tutorialScreen.pages){ig.global.tutorialScreen.activeTutorial++; this.durationTimer.set(ig.global.tutorialScreen.easingTime);};
			clearMouse();
		};
	
		this.parent();
    }
   
});

});