ig.module(
   'game.entities.winScreen'
)
.requires(
   'impact.entity'
)
.defines(function(){

EntityWinScreen = ig.Entity.extend({

	startingDelay : new ig.Timer(),
	exitTimer : new ig.Timer(),
	
	collides: ig.Entity.COLLIDES.NEVER,

	nadalImage : [
		new ig.Image( 'media/img/ui/win/nadal.png' ),
		new ig.Image( 'media/img/ui/slamwins/01.png' ),
		new ig.Image( 'media/img/ui/slamwins/02.png' ),
		new ig.Image( 'media/img/ui/slamwins/03.png' ),
		new ig.Image( 'media/img/ui/slamwins/04.png' )
	],

	init: function( x, y, settings ) { 
		clearMouse();
		ig.irontec.savePoints(10 + ig.global.game.hits);
		this.startingDelay.set(2);
		this.exitTimer.set(3);		
		ig.game.playSound('winSound');
		ig.game.increaseMaxLevel();
		this.parent( x, y, settings );
	},
   
   draw: function() {  
   
      this.parent();
      var ctx = ig.system.context;

      /* Plain Background */
      ctx.fillStyle= "#ffffff";
      ctx.fillRect( ig.global.game.xmin, 0, ig.global.game.width, ig.global.game.height );      
      
      /* Topbar */
      var grd = ctx.createLinearGradient(0,0,ig.global.game.width,ig.global.lostScreen.topBar.height);
      grd.addColorStop(0,"#006e91");
      grd.addColorStop(1,"#035d7a");
      ctx.fillStyle= grd;
      ctx.fillRect( ig.global.game.xmin, 0, ig.global.game.width, ig.global.lostScreen.topBar.height );
      
      /* Gradient Background */
      var grd = ctx.createLinearGradient(0,ig.global.lostScreen.gradient.y,0,ig.global.lostScreen.gradient.y + ig.global.lostScreen.gradient.height);
      grd.addColorStop(0,"#ffffff");
      grd.addColorStop(1,"#dcdcdc");
      ctx.fillStyle= grd;
      ctx.fillRect( ig.global.game.xmin, ig.global.lostScreen.gradient.y, ig.global.game.width, ig.global.lostScreen.gradient.height );   
      
      /* Title */
      ctx.fillStyle = '#ffd51b';
      var textFontSize = ig.global.lostScreen.title.height;
      var textX = ig.global.lostScreen.title.x;
      var textY = ig.global.lostScreen.title.y;
      ctx.font= textFontSize + "px HauracherellNC";
      ctx.textBaseline = 'middle';     
      ctx.textAlign = 'left'; 
      ctx.fillText( "BIEN HECHO!!", textX, textY );
         
      /* Image */
	  var $imagen;
	  switch(ig.global.game.level){
	  case 3 : $imagen = 1; break;
	  case 6 : $imagen = 2; break;
	  case 9 : $imagen = 3; break;
	  case 12 : $imagen = 4; break;
	  default : $imagen = 0; break;
	  }
      ig.system.context.drawImage( this.nadalImage[$imagen].data, ig.global.lostScreen.image.x, ig.global.lostScreen.image.y, ig.global.lostScreen.image.width, ig.global.lostScreen.image.height );

      /* Score text */
      ctx.fillStyle = '#1e6b95';
      var textFontSize = ig.global.lostScreen.score.height;
      var textX = ig.global.game.center;
      var textY = ig.global.lostScreen.score.y;
      ctx.font= textFontSize + "px HauracherellNC";
      ctx.textBaseline = 'top';     
      ctx.textAlign = 'center';  
      ctx.fillText( 'Has devuelto ' + ig.global.game.hits + ' pelotas', textX, textY );      

      /* Bottombar */
      var grd = ctx.createLinearGradient(ig.global.game.xmin, ig.global.lostScreen.bottomBar.y, ig.global.game.xmin, ig.global.lostScreen.bottomBar.y + ig.global.lostScreen.bottomBar.height);
      grd.addColorStop(0,"#006e91");
      grd.addColorStop(1,"#035d7a");
      ctx.fillStyle= grd;
      ctx.fillRect( ig.global.game.xmin, ig.global.lostScreen.bottomBar.y, ig.global.game.width, ig.global.lostScreen.bottomBar.height );    
        
      /* Vivefan score text */
      ctx.fillStyle = 'white';
      var textFontSize = ig.global.lostScreen.score.height;
      var textX = ig.global.game.center;
      var textY = ig.global.lostScreen.bottomBar.y + ig.global.lostScreen.bottomBar.height/2;
      ctx.font= textFontSize + "px HauracherellNC";
      ctx.textBaseline = 'middle';     
      ctx.textAlign = 'center';  
      ctx.fillText( 'Puntos Vivefan: ' + ig.global.game.hits, textX, textY );     	  
      
   },
   
    update: function() {

		if(this.exitTimer.delta()>0){	
			ig.game.saveLastGameDate();
			ig.game.exit();
		};	  
      
      this.parent();
    }
   
});

});
