ig.module(
   'game.globals' 
)
.defines(function(){

	if(window.innerHeight > window.innerWidth){
		ig.global.gameRatio = window.innerHeight/window.innerWidth;
	}else{
		ig.global.gameRatio = 1.5;
	}

	//Game Area
	ig.global.game = {};
	ig.global.game.height = window.innerHeight;
	ig.global.game.width = Math.round(window.innerHeight/ig.global.gameRatio);
	ig.global.game.xmin = (window.innerWidth - ig.global.game.width) / 2;
	ig.global.game.xmax = ig.global.game.xmin + ig.global.game.width;
	ig.global.game.center = ig.global.game.xmin + ig.global.game.width/2;
	ig.global.game.maxSpeed = 1.6;
	ig.global.game.paused = 1;
	ig.global.game.maxLevel = 1;

	//Loading Screen
	ig.global.loadingScreen = {text : {}, logo : {}, bar : {}};
	ig.global.loadingScreen.text.height = Math.round(0.06 * ig.global.game.height);
	ig.global.loadingScreen.text.y = Math.round(0.455 * ig.global.game.height);
	ig.global.loadingScreen.logo.height = Math.round(0.06 * ig.global.game.height);
	ig.global.loadingScreen.logo.width = Math.round(421/115 * ig.global.loadingScreen.logo.height);
	ig.global.loadingScreen.logo.y = Math.round(0.455 * ig.global.game.height);	
	ig.global.loadingScreen.logo.x = ig.global.game.center - ig.global.loadingScreen.logo.width/2;
	ig.global.loadingScreen.bar.height = Math.round(0.014 * ig.global.game.height);
	ig.global.loadingScreen.bar.width = Math.round(13.58 * ig.global.loadingScreen.bar.height);
	ig.global.loadingScreen.bar.y = Math.round(0.531 * ig.global.game.height); 
	ig.global.loadingScreen.bar.x = Math.round(ig.global.game.center - ig.global.loadingScreen.bar.width/2);

	//Home Screen
	ig.global.homeScreen = {topBar : {}, homeLogo : {}, background : {}, nadal : {}, title : {}, playButton : {}, tutorialButton : {}, exitButton : {}};
	ig.global.homeScreen.topBar.height = Math.round(0.125 * ig.global.game.height);
	ig.global.homeScreen.homeLogo.height = Math.round(0.60 * ig.global.homeScreen.topBar.height);
	ig.global.homeScreen.homeLogo.width = Math.round(421/115 * ig.global.homeScreen.homeLogo.height);
	ig.global.homeScreen.homeLogo.x = Math.round(ig.global.game.center - ig.global.homeScreen.homeLogo.width/2);
	ig.global.homeScreen.homeLogo.y = Math.round((ig.global.homeScreen.topBar.height - ig.global.homeScreen.homeLogo.height)/1.6);
	ig.global.homeScreen.background.height = Math.round(0.50 * ig.global.game.height);
	ig.global.homeScreen.background.width = Math.round(1350/700 * ig.global.homeScreen.background.height);
	ig.global.homeScreen.background.x = Math.round(ig.global.game.center - ig.global.homeScreen.background.width/2);
	ig.global.homeScreen.background.y = ig.global.homeScreen.topBar.height;
	ig.global.homeScreen.nadal.height = Math.round(0.38 * ig.global.game.height);
	ig.global.homeScreen.nadal.width = Math.round(452/568 * ig.global.homeScreen.nadal.height);
	ig.global.homeScreen.nadal.x = Math.round(ig.global.game.center - ig.global.homeScreen.nadal.width/2);
	ig.global.homeScreen.nadal.y = ig.global.homeScreen.topBar.height + Math.round(0.02 * ig.global.game.height);
	ig.global.homeScreen.title.height = Math.round(0.23 * ig.global.game.height);
	ig.global.homeScreen.title.width = Math.round(603/334 * ig.global.homeScreen.title.height);
	ig.global.homeScreen.title.x = Math.round(ig.global.game.center - ig.global.homeScreen.title.width/2);
	ig.global.homeScreen.title.y = ig.global.homeScreen.nadal.y + 0.95 * ig.global.homeScreen.nadal.height;
	ig.global.homeScreen.playButton.width = Math.round(0.92 * ig.global.game.width);
	ig.global.homeScreen.playButton.height = Math.round(0.1 * ig.global.game.height);
	ig.global.homeScreen.playButton.x = Math.round(ig.global.game.xmin + 0.04 * ig.global.game.width);
	ig.global.homeScreen.playButton.y = Math.round(0.78 * ig.global.game.height);
	ig.global.homeScreen.playButton.releasedY = ig.global.homeScreen.playButton.y;
	ig.global.homeScreen.playButton.pressedY = Math.round(ig.global.homeScreen.playButton.releasedY + 0.006 * ig.global.game.height);   
	ig.global.homeScreen.tutorialButton.width = Math.round(0.92 * ig.global.game.width);
	ig.global.homeScreen.tutorialButton.height = Math.round(0.07 * ig.global.game.height);
	ig.global.homeScreen.tutorialButton.x = Math.round(ig.global.game.xmin + 0.04 * ig.global.game.width);
	ig.global.homeScreen.tutorialButton.y = Math.round(0.90 * ig.global.game.height);   
	ig.global.homeScreen.tutorialButton.releasedY = ig.global.homeScreen.tutorialButton.y;
	ig.global.homeScreen.tutorialButton.pressedY = Math.round(ig.global.homeScreen.tutorialButton.releasedY + 0.006 * ig.global.game.height);
	ig.global.homeScreen.exitButton.height = Math.round(0.08 * ig.global.game.height);
	ig.global.homeScreen.exitButton.width = ig.global.homeScreen.exitButton.height;
	ig.global.homeScreen.exitButton.y = Math.round((ig.global.homeScreen.topBar.height - ig.global.homeScreen.exitButton.height)/2); 
	ig.global.homeScreen.exitButton.x = ig.global.game.xmin + Math.round(ig.global.homeScreen.exitButton.y);
	ig.global.homeScreen.exitButton.releasedY = ig.global.homeScreen.exitButton.y;
	ig.global.homeScreen.exitButton.pressedY = Math.round(ig.global.homeScreen.exitButton.releasedY + 0.006 * ig.global.game.height);

	//Tutorial Screen
	ig.global.tutorialScreen = {topBar : {}, title : {}, homeButton : {}, imageArea : {}, image : {}, textArea : {}, bubble : {}, bubbleTriangle : {}, text : {}, pagination : {}, balls : {}, previousButton : {}, nextButton : {}};
	ig.global.tutorialScreen.activeTutorial = 1;
	ig.global.tutorialScreen.topBar.height = Math.round(0.125 * ig.global.game.height);
	ig.global.tutorialScreen.title.x = Math.round(ig.global.game.xmin + 0.25 * ig.global.tutorialScreen.topBar.height);
	ig.global.tutorialScreen.title.y = Math.round(0.5 * ig.global.tutorialScreen.topBar.height);
	ig.global.tutorialScreen.title.height = Math.round(0.5 * ig.global.tutorialScreen.topBar.height);
	ig.global.tutorialScreen.homeButton.height = Math.round(0.08 * ig.global.game.height);
	ig.global.tutorialScreen.homeButton.width = ig.global.tutorialScreen.homeButton.height;
	ig.global.tutorialScreen.homeButton.y = Math.round((ig.global.tutorialScreen.topBar.height - ig.global.tutorialScreen.homeButton.height)/2);   
	ig.global.tutorialScreen.homeButton.x = Math.round(ig.global.game.xmax - (ig.global.tutorialScreen.homeButton.y + ig.global.tutorialScreen.homeButton.width));
	ig.global.tutorialScreen.homeButton.releasedY = ig.global.tutorialScreen.homeButton.y;
	ig.global.tutorialScreen.homeButton.pressedY = Math.round(ig.global.tutorialScreen.homeButton.releasedY + 0.006 * ig.global.game.height);
	ig.global.tutorialScreen.imageArea.height = Math.round(0.415 * ig.global.game.height);
	ig.global.tutorialScreen.imageArea.y = ig.global.tutorialScreen.topBar.height;
	ig.global.tutorialScreen.easingTime = 0.6;
	ig.global.tutorialScreen.image.height = Math.round(0.36 * ig.global.game.height);
	ig.global.tutorialScreen.image.width = Math.round(0.36 * ig.global.game.height); 
	ig.global.tutorialScreen.image.x = Math.round(ig.global.game.xmin + (ig.global.game.width - ig.global.tutorialScreen.image.width)/2);
	ig.global.tutorialScreen.image.y = Math.round(ig.global.tutorialScreen.imageArea.y + (ig.global.tutorialScreen.imageArea.height - ig.global.tutorialScreen.image.height)/2);
	ig.global.tutorialScreen.bubble.height = Math.round(0.24 * ig.global.game.height);
	ig.global.tutorialScreen.bubble.width = Math.round(0.92 * ig.global.game.width);
	ig.global.tutorialScreen.bubble.x = Math.round(ig.global.game.xmin + 0.04 * ig.global.game.width);
	ig.global.tutorialScreen.bubble.y = Math.round(ig.global.tutorialScreen.imageArea.y + ig.global.tutorialScreen.imageArea.height + 0.03 * ig.global.game.width);
	ig.global.tutorialScreen.bubbleTriangle.x1 = Math.round(ig.global.tutorialScreen.bubble.x + 0.09 * ig.global.tutorialScreen.bubble.width);
	ig.global.tutorialScreen.bubbleTriangle.x2 = Math.round(ig.global.tutorialScreen.bubble.x + 0.14 * ig.global.tutorialScreen.bubble.width);	
	ig.global.tutorialScreen.bubbleTriangle.xc = Math.round(ig.global.tutorialScreen.bubble.x + 0.115 * ig.global.tutorialScreen.bubble.width);	
	ig.global.tutorialScreen.bubbleTriangle.height = Math.round(2/3 * (ig.global.tutorialScreen.bubbleTriangle.x2 - ig.global.tutorialScreen.bubbleTriangle.x1));  
	ig.global.tutorialScreen.pages = 5;
	ig.global.tutorialScreen.pagination.y = Math.round(0.875 * ig.global.game.height);
	ig.global.tutorialScreen.pagination.height = Math.round(0.05 * ig.global.game.height);
	ig.global.tutorialScreen.balls.y = Math.round(0.97 * ig.global.game.height);
	ig.global.tutorialScreen.balls.radius = Math.round(0.01 * ig.global.game.height);
	ig.global.tutorialScreen.balls.margin = ig.global.tutorialScreen.balls.radius
	ig.global.tutorialScreen.balls.x = ig.global.game.xmin + (ig.global.game.width/2) - ((ig.global.tutorialScreen.pages - 1) * ig.global.tutorialScreen.balls.radius) - ((ig.global.tutorialScreen.pages - 1)/2 * ig.global.tutorialScreen.balls.margin);
	ig.global.tutorialScreen.previousButton.height = Math.round(0.1 * ig.global.game.height);
	ig.global.tutorialScreen.previousButton.width = Math.round(0.1 * ig.global.game.height);
	ig.global.tutorialScreen.previousButton.y = Math.round(0.88 * ig.global.game.height);
	ig.global.tutorialScreen.previousButton.x = Math.round(ig.global.game.xmin);
	ig.global.tutorialScreen.nextButton.height = Math.round(0.1 * ig.global.game.height);
	ig.global.tutorialScreen.nextButton.width = Math.round(0.1 * ig.global.game.height);
	ig.global.tutorialScreen.nextButton.y = Math.round(0.88 * ig.global.game.height);
	ig.global.tutorialScreen.nextButton.x = Math.round(ig.global.game.xmin + 0.86 * ig.global.game.width);

	//Lost Screen
	ig.global.lostScreen = {topBar : {}, title : {}, homeButton : {}, gradient : {}, image : {}, score : {}, bottomBar : {}, playAgainButton : {}};
	ig.global.lostScreen.activeTutorial = 1;
	ig.global.lostScreen.topBar.height = Math.round(0.125 * ig.global.game.height);
	ig.global.lostScreen.title.x = Math.round(ig.global.game.xmin + 0.25 * ig.global.lostScreen.topBar.height);
	ig.global.lostScreen.title.y = Math.round(0.5 * ig.global.lostScreen.topBar.height);
	ig.global.lostScreen.title.height = Math.round(0.5 * ig.global.lostScreen.topBar.height);
	ig.global.lostScreen.homeButton.height = Math.round(0.08 * ig.global.game.height);
	ig.global.lostScreen.homeButton.width = ig.global.lostScreen.homeButton.height;
	ig.global.lostScreen.homeButton.y = Math.round((ig.global.lostScreen.topBar.height - ig.global.lostScreen.homeButton.height)/2);   
	ig.global.lostScreen.homeButton.x = Math.round(ig.global.game.xmax - (ig.global.lostScreen.homeButton.y + ig.global.lostScreen.homeButton.width));
	ig.global.lostScreen.homeButton.releasedY = ig.global.lostScreen.homeButton.y;
	ig.global.lostScreen.homeButton.pressedY = Math.round(ig.global.lostScreen.homeButton.releasedY + 0.006 * ig.global.game.height);
	ig.global.lostScreen.gradient.height = Math.round(0.75 * ig.global.game.height);
	ig.global.lostScreen.gradient.y = ig.global.lostScreen.topBar.height;
	ig.global.lostScreen.image.height = Math.round(0.54 * ig.global.game.height);
	ig.global.lostScreen.image.width = Math.round(957/1176 * ig.global.lostScreen.image.height); 
	ig.global.lostScreen.image.x = Math.round(ig.global.game.xmin + (ig.global.game.width - ig.global.lostScreen.image.width)/2);
	ig.global.lostScreen.image.y = Math.round(0.17 * ig.global.game.height);
	ig.global.lostScreen.score.y = Math.round(0.76 * ig.global.game.height);   
	ig.global.lostScreen.score.height = Math.round(0.06 * ig.global.game.height);
	ig.global.lostScreen.bottomBar.y = Math.round(0.85 * ig.global.game.height);
	ig.global.lostScreen.bottomBar.height = Math.round(0.15 * ig.global.game.height);
	ig.global.lostScreen.playAgainButton.width = Math.round(0.92 * ig.global.game.width);
	ig.global.lostScreen.playAgainButton.height = Math.round(0.1 * ig.global.game.height);
	ig.global.lostScreen.playAgainButton.x = Math.round(ig.global.game.xmin + 0.04 * ig.global.game.width);
	ig.global.lostScreen.playAgainButton.y = Math.round(0.875 * ig.global.game.height);   
	ig.global.lostScreen.playAgainButton.releasedY = ig.global.lostScreen.playAgainButton.y;
	ig.global.lostScreen.playAgainButton.pressedY = Math.round(ig.global.lostScreen.playAgainButton.releasedY + 0.006 * ig.global.game.height);

	//Level Selector Screen
	ig.global.levelsMenuScreen = {topBar : {}, title : {}, homeButton : {}, open : {}};
	ig.global.levelsMenuScreen.topBar.height = Math.round(0.125 * ig.global.game.height);
	ig.global.levelsMenuScreen.title.x = Math.round(ig.global.game.xmin + 0.25 * ig.global.levelsMenuScreen.topBar.height);
	ig.global.levelsMenuScreen.title.y = Math.round(0.5 * ig.global.levelsMenuScreen.topBar.height);
	ig.global.levelsMenuScreen.title.height = Math.round(0.5 * ig.global.levelsMenuScreen.topBar.height);
	ig.global.levelsMenuScreen.homeButton.height = Math.round(0.08 * ig.global.game.height);
	ig.global.levelsMenuScreen.homeButton.width = ig.global.levelsMenuScreen.homeButton.height;
	ig.global.levelsMenuScreen.homeButton.y = Math.round((ig.global.levelsMenuScreen.topBar.height - ig.global.levelsMenuScreen.homeButton.height)/2);   
	ig.global.levelsMenuScreen.homeButton.x = Math.round(ig.global.game.xmax - (ig.global.levelsMenuScreen.homeButton.y + ig.global.levelsMenuScreen.homeButton.width));
	ig.global.levelsMenuScreen.homeButton.releasedY = ig.global.levelsMenuScreen.homeButton.y;
	ig.global.levelsMenuScreen.homeButton.pressedY = Math.round(ig.global.levelsMenuScreen.homeButton.releasedY + 0.006 * ig.global.game.height);
	ig.global.levelsMenuScreen.easingTime = 0.6;
	ig.global.levelsMenuScreen.open.scroll = ig.global.levelsMenuScreen.topBar.height;
	ig.global.levelsMenuScreen.open.height = Math.round(0.25 * ig.global.game.height);
	
	//Level Screen
	ig.global.levelScreen = {topBar : {}, title : {}, backButton : {}, imageArea : {}, image : {}, textArea : {}, bubble : {}, bubbleTriangle : {}, text : {}, bottomBar : {}, playButton : {}, text : []};
	ig.global.levelScreen.topBar.height = Math.round(0.125 * ig.global.game.height);
	ig.global.levelScreen.title.x = Math.round(ig.global.game.xmin + 0.25 * ig.global.levelScreen.topBar.height);
	ig.global.levelScreen.title.y = Math.round(0.5 * ig.global.levelScreen.topBar.height);
	ig.global.levelScreen.title.height = Math.round(0.5 * ig.global.levelScreen.topBar.height);
	ig.global.levelScreen.backButton.height = Math.round(0.08 * ig.global.game.height);
	ig.global.levelScreen.backButton.width = ig.global.levelScreen.backButton.height;
	ig.global.levelScreen.backButton.y = Math.round((ig.global.levelScreen.topBar.height - ig.global.levelScreen.backButton.height)/2);   
	ig.global.levelScreen.backButton.x = Math.round(ig.global.game.xmax - (ig.global.levelScreen.backButton.y + ig.global.levelScreen.backButton.width));
	ig.global.levelScreen.backButton.releasedY = ig.global.levelScreen.backButton.y;
	ig.global.levelScreen.backButton.pressedY = Math.round(ig.global.levelScreen.backButton.releasedY + 0.006 * ig.global.game.height);
	ig.global.levelScreen.easingTime = 0.6;
	ig.global.levelScreen.imageArea.height = Math.round(0.30 * ig.global.game.height);
	ig.global.levelScreen.imageArea.y = ig.global.levelScreen.topBar.height;
	ig.global.levelScreen.image.height = Math.round(0.28 * ig.global.game.height);
	ig.global.levelScreen.image.width = Math.round(720/450 * ig.global.levelScreen.image.height); 
	ig.global.levelScreen.image.x = Math.round(ig.global.game.xmin + (ig.global.game.width - ig.global.levelScreen.image.width)/2);
	ig.global.levelScreen.image.y = Math.round(ig.global.levelScreen.imageArea.y + ig.global.levelScreen.imageArea.height - ig.global.levelScreen.image.height);
	ig.global.levelScreen.bubble.height = Math.round(0.37 * ig.global.game.height);
	ig.global.levelScreen.bubble.width = Math.round(0.92 * ig.global.game.width);
	ig.global.levelScreen.bubble.x = Math.round(ig.global.game.xmin + (ig.global.game.width - ig.global.levelScreen.bubble.width)/2);
	ig.global.levelScreen.bubble.y = Math.round(ig.global.levelScreen.imageArea.y + ig.global.levelScreen.imageArea.height + 0.03 * ig.global.game.height);
	ig.global.levelScreen.bubbleTriangle.x1 = Math.round(ig.global.levelScreen.bubble.x + 0.09 * ig.global.levelScreen.bubble.width);
	ig.global.levelScreen.bubbleTriangle.x2 = Math.round(ig.global.levelScreen.bubble.x + 0.14 * ig.global.levelScreen.bubble.width);	
	ig.global.levelScreen.bubbleTriangle.xc = Math.round(ig.global.levelScreen.bubble.x + 0.115 * ig.global.levelScreen.bubble.width);	
	ig.global.levelScreen.bubbleTriangle.height = Math.round(2/3 * (ig.global.levelScreen.bubbleTriangle.x2 - ig.global.levelScreen.bubbleTriangle.x1));  	
	ig.global.levelScreen.bottomBar.y = Math.round(0.85 * ig.global.game.height);
	ig.global.levelScreen.bottomBar.height = Math.round(0.15 * ig.global.game.height);
	ig.global.levelScreen.playButton.width = Math.round(0.92 * ig.global.game.width);
	ig.global.levelScreen.playButton.height = Math.round(0.1 * ig.global.game.height);
	ig.global.levelScreen.playButton.x = Math.round(ig.global.game.xmin + 0.04 * ig.global.game.width);
	ig.global.levelScreen.playButton.y = Math.round(0.875 * ig.global.game.height);   
	ig.global.levelScreen.playButton.releasedY = ig.global.levelScreen.playButton.y;
	ig.global.levelScreen.playButton.pressedY = Math.round(ig.global.levelScreen.playButton.releasedY + 0.006 * ig.global.game.height);

		//Level Screen Texts
		//Australia
		ig.global.levelScreen.text[1] = new Array;		
		ig.global.levelScreen.text[1][0] = 'Torneo disputado sobre pista de';
		ig.global.levelScreen.text[1][1] = 'tenis dura acrílica que exige un';
		ig.global.levelScreen.text[1][2] = 'juego de altísima velocidad.';
		ig.global.levelScreen.text[1][3] = ' ';
		ig.global.levelScreen.text[1][4] = 'Tu oponente será Nick Boomerang,';
		ig.global.levelScreen.text[1][5] = 'conocido por su juego agresivo';
		ig.global.levelScreen.text[1][6] = 'y temido por su potente revés.';	

		//Francia
		ig.global.levelScreen.text[2] = new Array;		
		ig.global.levelScreen.text[2][0] = 'Torneo disputado sobre pista';
		ig.global.levelScreen.text[2][1] = 'de tierra batida, ideal para';
		ig.global.levelScreen.text[2][2] = 'jugadores fondistas.';
		ig.global.levelScreen.text[2][3] = ' ';
		ig.global.levelScreen.text[2][4] = "Tu oponente será Alain Levite,";
		ig.global.levelScreen.text[2][5] = 'conocido por ser uno de los tenistas';
		ig.global.levelScreen.text[2][6] = 'más rápidos del circuito.';	
		
		//UK
		ig.global.levelScreen.text[3] = new Array;		
		ig.global.levelScreen.text[3][0] = 'Torneo disputado sobre pista de';
		ig.global.levelScreen.text[3][1] = 'hierba con botes irregulares y con';
		ig.global.levelScreen.text[3][2] = 'cambios de altura y dirección.';
		ig.global.levelScreen.text[3][3] = ' ';
		ig.global.levelScreen.text[3][4] = "Tu oponente será Tim O'Tea,";
		ig.global.levelScreen.text[3][5] = 'uno de los mejores tenistas, hasta';
		ig.global.levelScreen.text[3][6] = 'ahora imbatible en pistas de hierba.';			

		//EEUU
		ig.global.levelScreen.text[4] = new Array;			
		ig.global.levelScreen.text[4][0] = 'Torneo disputado sobre una pista';
		ig.global.levelScreen.text[4][1] = 'dura acrílica, con botes bajos y';
		ig.global.levelScreen.text[4][2] = 'rápidos y puntos más cortos.';
		ig.global.levelScreen.text[4][3] = ' ';
		ig.global.levelScreen.text[4][4] = 'Tu oponente será James McRacket,';
		ig.global.levelScreen.text[4][5] = 'conocido por tener una de las';
		ig.global.levelScreen.text[4][6] = 'derechas más potentes del circuito.';	
	
	//Pause Screen
	ig.global.pauseScreen = {continueButton : {}, exitButton : {}, soundButton : {}};   
	ig.global.pauseScreen.continueButton.width = Math.round(0.92 * ig.global.game.width);
	ig.global.pauseScreen.continueButton.height = Math.round(0.072 * ig.global.game.height);
	ig.global.pauseScreen.continueButton.x = Math.round(ig.global.game.xmin + 0.04 * ig.global.game.width);
	ig.global.pauseScreen.continueButton.y = Math.round(0.38 * ig.global.game.height);
	ig.global.pauseScreen.continueButton.releasedY = ig.global.pauseScreen.continueButton.y;
	ig.global.pauseScreen.continueButton.pressedY = Math.round(ig.global.pauseScreen.continueButton.releasedY + 0.006 * ig.global.game.height);  
	ig.global.pauseScreen.exitButton.width = Math.round(0.78 * ig.global.game.width);
	ig.global.pauseScreen.exitButton.height = Math.round(0.058 * ig.global.game.height);
	ig.global.pauseScreen.exitButton.x = Math.round(ig.global.game.xmin + 0.11 * ig.global.game.width);
	ig.global.pauseScreen.exitButton.y = Math.round(0.471 * ig.global.game.height);  
	ig.global.pauseScreen.exitButton.releasedY = ig.global.pauseScreen.exitButton.y;
	ig.global.pauseScreen.exitButton.pressedY = Math.round(ig.global.pauseScreen.exitButton.releasedY + 0.006 * ig.global.game.height); 
	ig.global.pauseScreen.soundButton.height = Math.round(0.08 * ig.global.game.height);
	ig.global.pauseScreen.soundButton.width = ig.global.pauseScreen.soundButton.height;
	ig.global.pauseScreen.soundButton.y = Math.round(0.98 * ig.global.game.height - ig.global.pauseScreen.soundButton.height);   
	ig.global.pauseScreen.soundButton.x = Math.round(ig.global.game.xmax - (0.02 * ig.global.game.height + ig.global.pauseScreen.soundButton.width));
	ig.global.pauseScreen.soundButton.releasedY = ig.global.pauseScreen.soundButton.y;
	ig.global.pauseScreen.soundButton.pressedY = Math.round(ig.global.pauseScreen.soundButton.releasedY + 0.006 * ig.global.game.height);
	
	//TopBar Area  
	ig.global.topBar = {};
	ig.global.topBar.height = Math.round(ig.global.game.height * 0.1);
	ig.global.topBar.width = ig.global.game.width;

      //pauseButton  
      ig.global.pauseButton = {y : {}};
      ig.global.pauseButton.height = Math.round(0.6 * ig.global.topBar.height);
      ig.global.pauseButton.width = ig.global.pauseButton.height
      ig.global.pauseButton.x = Math.round(ig.global.game.xmin + 0.04 * ig.global.topBar.width);
      ig.global.pauseButton.y = Math.round(0.20 * ig.global.topBar.height);         
      ig.global.pauseButton.releasedY = ig.global.pauseButton.y;     
      ig.global.pauseButton.pressedY = Math.round(0.20 * ig.global.topBar.height + 0.006 * ig.global.game.height);
      
      //LifeBar
      ig.global.game.lifeBar = {};
      ig.global.game.lifeBar.x = Math.round(ig.global.pauseButton.x + ig.global.pauseButton.width + 0.05 * ig.global.topBar.width);
      ig.global.game.lifeBar.y = Math.round(0.2 * ig.global.topBar.height);
      ig.global.game.lifeBar.height = Math.round(0.6 * ig.global.topBar.height);
      ig.global.game.lifeBar.width = Math.round(ig.global.topBar.width * 0.515);

      //Score
      ig.global.score = {};
      ig.global.score.x = Math.round(ig.global.game.lifeBar.x + ig.global.game.lifeBar.width + 0.05 * ig.global.topBar.width);
      ig.global.score.y = Math.round(0.2 * ig.global.topBar.height);
      ig.global.score.height = Math.round(0.6 * ig.global.topBar.height);
      ig.global.score.width = Math.round(ig.global.topBar.width/5);           
   
   //Pitch Area
   ig.global.pitch = { };
   ig.global.pitch.y = ig.global.topBar.height;
   ig.global.pitch.height = ig.global.game.height - ig.global.topBar.height;
   ig.global.pitch.width = ig.global.game.width;   

   //Court Area
   ig.global.court = { margin : { x : 0, y : 0}};
   ig.global.court.ratio = 1.45;
   ig.global.court.height = ig.global.game.height * 0.7; 
   ig.global.court.width = ig.global.court.height / ig.global.court.ratio;
   ig.global.court.margin.x = Math.round((ig.global.game.width - ig.global.court.width)/2);
   ig.global.court.margin.y = Math.round(ig.global.game.height * 0.065);
   ig.global.court.x = ig.global.game.xmin + ig.global.court.margin.x;     
   ig.global.court.y = ig.global.pitch.y + ig.global.court.margin.y;    
   ig.global.court.ymax = ig.global.court.y + ig.global.court.height;
   ig.global.let = {};
   ig.global.let.width = Math.round(ig.global.court.width * 1.16);
   ig.global.let.height = ig.global.let.width * 0.1;
   ig.global.let.x = ig.global.court.x - ig.global.court.width * 0.08;     
   ig.global.let.y = ig.global.court.y + ig.global.court.height/2 - 0.21 * ig.global.let.height;      
   
   //Player
   ig.global.player = {};
   ig.global.player.width = Math.round(ig.global.game.height * 0.1);
   ig.global.player.height = ig.global.player.width * 2/2.3;
   ig.global.player.y = Math.round((ig.global.court.y + ig.global.court.height) - 1.5 * ig.global.player.height);
   
   //Rival
   ig.global.rival = {};
   ig.global.rival.width = Math.round(ig.global.game.height * 0.1);
   ig.global.rival.height = ig.global.rival.width * 2/2.3;
   ig.global.rival.y = Math.round(ig.global.court.y - ig.global.rival.width/2);
   
   //Ball
   ig.global.ball = { store : {vel : {}}};   
   ig.global.ball.height = 0.028 * ig.global.game.height;   
   ig.global.ball.width = ig.global.ball.height;
   ig.global.ball.store.vel.x = 0;
   ig.global.ball.store.vel.y = 0;  
   
	//Energizers
	/* Energizer size patron: Bottle has got 0.7 of player's height */
	ig.global.energizers = { item : [] };
	ig.global.energizers.height = 0.7 * ig.global.player.height;
	ig.global.energizers.width = ig.global.energizers.height;
	ig.global.energizers.active = 0;
	ig.global.energizers.x = 0;

	//Disturbers
	/* Disturber size patron: Balls have got 0.5 of player's height */
	ig.global.disturbers = { item : [] };
	ig.global.disturbers.heightPattern = Math.round(0.5 * ig.global.player.height);
	ig.global.disturbers.active = 0;
	ig.global.disturbers.x = ig.global.game.xmin;
	ig.global.disturbers.y = ig.global.court.y + ig.global.court.height/2;	
	for(var i=0; i<=2; i++){
		ig.global.disturbers.item[i] = {};
	};
	
		/* 1 - Ball 1 110 x 110 */
		ig.global.disturbers.item[1].height = ig.global.disturbers.heightPattern;
		ig.global.disturbers.item[1].width = ig.global.disturbers.heightPattern;

		/* 2 - Ball 2 110 x 110 */
		ig.global.disturbers.item[2].height = ig.global.disturbers.heightPattern;
		ig.global.disturbers.item[2].width = ig.global.disturbers.heightPattern;
		
	//Damage Balls
	ig.global.damageBalls = { };
	ig.global.damageBalls.width = 1.2 * ig.global.ball.width;
	ig.global.damageBalls.height = 1.2 * ig.global.ball.height;
   
    /* Open vars */
	ig.global.open = [];
	for(var i=0; i<=4; i++){
		ig.global.open[i] = {};
	};
		/* Open 1 - Australia */
		ig.global.open[1].pitch = "#428dbc";
		ig.global.open[1].court = "#3d7ba2";
		/* Open 2 - France */
		ig.global.open[2].pitch = "#e6541b";
		/* Open 3 - UK */
		ig.global.open[3].pitch = "#76af0a";
		/* Open 4 - USA */		
		ig.global.open[4].pitch = "#95a58c";
		ig.global.open[4].court = "#7485a3";
	
});
