ig.module(
    'plugins.auxiliar'
)
.defines(function() {
	"use strict";
	
	ig.auxiliar = {},
	
    ig.auxiliar.radiusRectangle = function(ctx, x, y, width, height, radius, fill, stroke) {
		radius = Math.round(radius);
		if (typeof stroke == "undefined" ) { stroke = true; }
		if (typeof radius === "undefined") { radius = 5; }
		ctx.beginPath();
		ctx.moveTo(x + radius, y);
		ctx.lineTo(x + width - radius, y);
		ctx.quadraticCurveTo(x + width, y, x + width, y + radius);
		ctx.lineTo(x + width, y + height - radius);
		ctx.quadraticCurveTo(x + width, y + height, x + width - radius, y + height);
		ctx.lineTo(x + radius, y + height);
		ctx.quadraticCurveTo(x, y + height, x, y + height - radius);
		ctx.lineTo(x, y + radius);
		ctx.quadraticCurveTo(x, y, x + radius, y);
		ctx.closePath();
		if (stroke) { ctx.stroke(); }
		if (fill) { ctx.fill(); }        
	},
	
	ig.auxiliar.button = function(element){
		if( click.x >= element.x && click.x <= element.x + element.width &&  click.y >= element.y && click.y <= element.y + element.height ){
			element.y = element.pressedY;
		}else{
			element.y = element.releasedY;
		};		
	},
	
	ig.auxiliar.distribution = function(factor){
		return (Math.exp(factor)-1)/(Math.exp(1) - 1);
	},	
	
	ig.auxiliar.tutorialText = function (ctx, lines, line1, line2, line3, line4, moveY) {
		
		/* Graphic proportions: 1 line = 1/5 from bubble height  linespacing = 1/15 from bubble height */
		var height = 0.64 * ig.global.tutorialScreen.bubble.height;
		if(lines==3){var startSpacing = Math.round(height*(1/8)); }else{ var startSpacing = 0;};
		var lineHeight = Math.round(height*(1/4)*(9/10));	
		var lineSpacing = Math.round(height*(1/4)*(1/10));	
		var x = Math.round(ig.global.game.xmin + 0.5 * ig.global.game.width);
		var y = Math.round(moveY + 0.2 * ig.global.tutorialScreen.bubble.height);
		
		ctx.font= lineHeight + "px HauracherellNC";
		ctx.textBaseline = 'top';		
		ctx.textAlign = 'center';	
		ctx.fillText(line1, x, y + startSpacing);		
		ctx.fillText(line2, x, y + startSpacing + lineHeight + lineSpacing );		
		ctx.fillText(line3, x, y + startSpacing + 2 * lineHeight + 2 * lineSpacing );		
		if(lines==4){
			ctx.fillText(line4, x, y + startSpacing + 3 * lineHeight + 3 * lineSpacing );	
		};
		
	},
	
	ig.auxiliar.levelText = function (ctx, open, moveY) {
		
		var height = ig.global.levelScreen.bubble.height;
		var startSpacing = Math.round(height*(1/9));	
		var lineHeight = Math.round(height*(1/9) * (9/10));	
		var lineSpacing = Math.round(height*(1/9) * (1/10));	
		var x = Math.round(ig.global.game.xmin + 0.5 * ig.global.game.width);
		var y = Math.round(moveY);
		ctx.font= lineHeight + "px HauracherellNC";
		ctx.textBaseline = 'top';		
		ctx.textAlign = 'center';	
		for(var i=0; i<=6; i++){
			ctx.fillText(ig.global.levelScreen.text[open][i], x, y + startSpacing + i * (lineHeight + lineSpacing) );		
		}
	},	
	
	ig.auxiliar.outExpo = function(t){
		return - Math.pow( 2, -10 * t ) + 1;
	},

	ig.auxiliar.inExpo = function(t){
		return Math.pow( 2, 10 * (t - 1) );
	},

	ig.auxiliar.disturbersHeight = function(t){
	if (t < 0.85) {
		return Math.abs(Math.sin(3.1418 * (t - 0.85)));	
		}else{
		return 0.1 * Math.abs(Math.sin(10/1.5 * 3.1418 * (t - 1)));
		}
	},
	
	ig.auxiliar.clearMouse = function(){
		click.x = 0;
		click.y = 0;
		release.x = 0;
		release.y = 0;
		lastClick.x = 0;
		lastClick.y = 0;		
		lastMouse.x = 0;
		lastMouse.y = 0;			
	}	

});