ig.module(
	'game.entities.background'
)
.requires(
	'impact.entity'
)
.defines(function(){

EntityBackground = ig.Entity.extend({
	
	mountain : new ig.ParallaxAnimation("Mountain", backgrounds, 0, 0.0, 0.28 * ig.global.game.height, 0, 3, 0.002 * ig.global.game.width),
	hills : new ig.ParallaxAnimation("Hills", backgrounds, 0, 0.05 * ig.global.game.height, 0.23 * ig.global.game.height,  0.22 * ig.global.game.height, 3, 0.003 * ig.global.game.width),	
	grass : new ig.ParallaxAnimation("Grass", backgrounds, 0, 0.222 * ig.global.game.height, 0.06 * ig.global.game.height, 0, 6, 0.005 * ig.global.game.width),		
	road : new ig.ParallaxAnimation("Road2", backgrounds, 0, 0.28 * ig.global.game.height, 0.72 * ig.global.game.height, 0, 14, 0.005 * ig.global.game.width),		
	movistarPanel : new ig.ParallaxAnimation("MovistarPanel", backgrounds, 0.5 * ig.global.game.width, 0.042 * ig.global.game.height, 0.24 * ig.global.game.height, 3 * ig.global.game.width, 1, 0.005 * ig.global.game.width),		
	
	m2001 : null, m2002 : null, m1001 : null, m1002 : null, m5001 : null, m5002 : null, finishLine1 : null, finishLine2 : null,

	collides: ig.Entity.COLLIDES.NEVER,
	
	init: function( x, y, settings ) {
		this.parent(x, y, settings);
		clearMouse();
	},
	
	draw : function(){
	
	
	
		this.mountain.draw();
		this.hills.draw();
		this.grass.draw();
		this.road.draw();
		this.movistarPanel.draw();		
		
		if(this.m5001 != null){
			this.m5001.draw();	
			this.m5002.draw();
		}
		if(this.m2001 != null){
			this.m2001.draw();	
			this.m2002.draw();
		}
		if(this.m1001 != null){
			this.m1001.draw();
			this.m1002.draw();
		}	
		if(this.finishLine1 != null){
			this.finishLine1.draw();	
			this.finishLine2.draw();
		}			
		
	},
	
	update: function() {
		this.mountain.update();
		this.hills.update();
		this.grass.update();
		this.road.update();	
		this.movistarPanel.update();	

		if(this.m5001 != null){
			this.m5001.update();	
			this.m5002.update();
		}
		if(this.m2001 != null){
			this.m2001.update();	
			this.m2002.update();
		}		
		if(this.m1001 != null){
			this.m1001.update();
			this.m1002.update();
		}	
		if(this.finishLine1 != null){
			this.finishLine1.update();	
			this.finishLine2.update();
		}			

		if(ig.game.timer.delta() > ig.global.game.race500  && this.m5001 == null){
			this.m5001 = new ig.ParallaxAnimation("M500", backgrounds, ig.global.game.width, 0.36 * ig.global.game.height, 0.2 * ig.global.game.height, 0, 1, 0.005 * ig.global.game.width);
			this.m5002 = new ig.ParallaxAnimation("M500", backgrounds, ig.global.game.width, 0.69 * ig.global.game.height, 0.2 * ig.global.game.height, 0, 1, 0.005 * ig.global.game.width);
		}
		if(ig.game.timer.delta() > ig.global.game.race200 && this.m2001 == null){
			this.m2001 = new ig.ParallaxAnimation("M200", backgrounds, ig.global.game.width, 0.36 * ig.global.game.height, 0.2 * ig.global.game.height, 0, 1, 0.005 * ig.global.game.width);
			this.m2002 = new ig.ParallaxAnimation("M200", backgrounds, ig.global.game.width, 0.69 * ig.global.game.height, 0.2 * ig.global.game.height, 0, 1, 0.005 * ig.global.game.width);	
		}
		if(ig.game.timer.delta() > ig.global.game.race100  && this.m1001 == null){
			this.m1001 = new ig.ParallaxAnimation("M100", backgrounds, ig.global.game.width, 0.36 * ig.global.game.height, 0.2 * ig.global.game.height, 0, 1, 0.005 * ig.global.game.width);
			this.m1002 = new ig.ParallaxAnimation("M100", backgrounds, ig.global.game.width, 0.69 * ig.global.game.height, 0.2 * ig.global.game.height, 0, 1, 0.005 * ig.global.game.width);	
		}
		if(ig.game.timer.delta() > 0 && this.finishLine1 == null){
			this.finishLine1 = new ig.ParallaxAnimation("Meta", backgrounds, ig.global.game.width, 0.33 * ig.global.game.height, 0.26 * ig.global.game.height, 0, 1, 0.005 * ig.global.game.width);
			this.finishLine2 = new ig.ParallaxAnimation("Meta", backgrounds, ig.global.game.width, 0.65 * ig.global.game.height, 0.28 * ig.global.game.height, 0, 1, 0.005 * ig.global.game.width);	
		}		
		
		this.parent();
   }	
});

});