ig.module(
	'game.entities.finish'
)
.requires(
	'impact.entity'
)
.defines(function(){

EntityFinish = ig.Entity.extend({

	collides: ig.Entity.COLLIDES.NEVER,
	
	line1 : new ig.TextLine("FIN DEL JUEGO", Math.floor( 0.5 * ig.global.game.width ), Math.floor( 0.15 * ig.global.game.height ), Math.floor( 0.12 * ig.global.game.height ),'AMCAP', 'top', 'center', '#FFFFFF',1),		
	line2 : new ig.TextLine("", Math.floor( 0.5 * ig.global.game.width ), Math.floor( 0.28 * ig.global.game.height ), Math.floor( 0.075 * ig.global.game.height ),'HCM','top','center','white',1),	
	totalPoints : new ig.UIObject("PuntuacionTotal.png", ui, 0.5 * ig.global.game.width - (0.54 * ig.global.game.width)/2, 0.4 * ig.global.game.height, 0.54 * ig.global.game.width * 79/749,1),
	totalPointsText : new ig.TextLine(0, Math.floor( 0.5 * ig.global.game.width ) + 0.54 * ig.global.game.width * 0.25, Math.floor( 0.4 * ig.global.game.height ) + (0.54 * ig.global.game.width * 79/749)/2, Math.floor( 0.07 * ig.global.game.height ),'AMCAP', 'middle', 'left', '#FFFFFF',1),		
	vivefanPoints : new ig.UIObject("PuntosViveFan.png", ui, 0.5 * ig.global.game.width - (0.54 * ig.global.game.width)/2, 0.53 * ig.global.game.height, 0.54 * ig.global.game.width * 80/749,1),
	vivefanPointsText : new ig.TextLine(0, Math.floor( 0.5 * ig.global.game.width ) + 0.54 * ig.global.game.width * 0.27, Math.floor( 0.53 * ig.global.game.height ) + (0.54 * ig.global.game.width * 80/749)/2, Math.floor( 0.07 * ig.global.game.height ),'AMCAP','middle','left','white',1),	
	
	exitButton : new ig.Button("Salir.png", ui, 0.5 * ig.global.game.width - (0.29 * ig.global.game.width)/2, 0.71 * ig.global.game.height, 0.29 * ig.global.game.width * 90/587,1, function (){
		ig.game.exit();
	}),		
	
	init: function( x, y, settings ) {
		this.parent(x, y, settings);
		
		this.line2.y = this.line1.y + this.line1.fontSize + 0.005 * ig.global.game.height;
		this.totalPoints.y = this.line2.y + this.line1.fontSize + 0.005 * ig.global.game.height;
		this.totalPointsText.y = this.totalPoints.y + this.totalPoints.h * 0.5;
		this.vivefanPoints.y = this.totalPoints.y + this.totalPoints.h;
		this.vivefanPointsText.y = this.vivefanPoints.y + this.vivefanPoints.h * 0.5;
		this.exitButton.button.y = this.vivefanPoints.y + this.vivefanPoints.h + 0.05 * ig.global.game.height;
		
		clearMouse();
	},		

	draw : function(){
		
		var ctx = ig.system.context;

		//Background
		ctx.fillStyle = 'black';
		ctx.globalAlpha = 0.5;
		ctx.fillRect(0,0,ig.global.game.width,ig.global.game.height);		
		ctx.globalAlpha = 1;

		this.line1.draw();
		this.line2.draw();
		
		this.totalPoints.draw();
		this.totalPointsText.draw();
		this.vivefanPoints.draw();
		this.vivefanPointsText.draw();
	
		this.exitButton.draw();			

	},
	
	update: function() {
		this.exitButton.update();	
		if(ig.game.finished == 1 && this.vivefanPointsText.text==0){
			if(ig.game.level<16){
				this.line2.text = "NO HAS ALCANZADO LA PUNTUACIÓN MÍNIMA";
			}else{
				this.line2.text = "HAS SUPERADO TODOS LOS NIVELES";
			};		
			this.totalPointsText.text = ig.game.score;
			this.vivefanPointsText.text = ig.game.vivefanScore;
		}
		this.parent();
	}	
});

});