ig.module(
	'game.entities.intro'
)
.requires(
	'impact.entity'
)
.defines(function(){

EntityIntro = ig.Entity.extend({

	collides: ig.Entity.COLLIDES.NEVER,
	
	logo : new ig.UIObject("Logo.png", ui, 0.5 * ig.global.game.width - ((900/252) * 0.30 * ig.global.game.height)/2, 0.14 * ig.global.game.height, 0.30 * ig.global.game.height,1),
	
	playButton : new ig.Button("Jugar.png", ui, 0.5 * ig.global.game.width - ((587/90) * 0.16 * ig.global.game.height)/2, 0.50 * ig.global.game.height, 0.16 * ig.global.game.height,1, function (){
		ig.game.play();
	}),

	tutorialButton : new ig.Button("Tutorial.png", ui, 0.5 * ig.global.game.width - ((587/90) * 0.16 * ig.global.game.height)/2, 0.70 * ig.global.game.height, 0.16 * ig.global.game.height,1, function (){
		ig.game.tutorial();
	}),	
	
	recordText : new ig.TextLine("RÉCORD DE ETAPAS: ", Math.floor( 0.5 * ig.global.game.width ), Math.floor( 0.90 * ig.global.game.height ), Math.floor( 0.03 * ig.global.game.height ),'AMCAP', 'top', 'center', '#FFFFFF',1),		
		
	init: function( x, y, settings ) {
		this.parent(x, y, settings);
		clearMouse();
	},		
		
	draw : function(){
		this.logo.draw();	
		this.playButton.draw();	
		this.tutorialButton.draw();			
		this.recordText.draw();	

	},
	
	update: function() {
		this.recordText.text = "RÉCORD DE ETAPAS: " + ig.game.recordLevel; 
		this.playButton.update();	
		this.tutorialButton.update();			
		this.recordText.draw();	
		this.parent();
   }	
});

});