ig.module(
	'game.entities.pause'
)
.requires(
	'impact.entity'
)
.defines(function(){

EntityPause = ig.Entity.extend({

	collides: ig.Entity.COLLIDES.NEVER,
				
	init: function( x, y, settings ) {
		this.parent(x, y, settings);
		clearMouse();	
	},			

	continueButton : new ig.Button("Continuar.png", ui, 0.5 * ig.global.game.width - ((587/90) * 0.16 * ig.global.game.height)/2, 0.24 * ig.global.game.height, 0.16 * ig.global.game.height,1, function (){
		ig.game.unpause();
	}),

	tutorialButton : new ig.Button("Tutorial.png", ui, 0.5 * ig.global.game.width - ((587/90) * 0.16 * ig.global.game.height)/2, 0.42 * ig.global.game.height, 0.16 * ig.global.game.height,1, function (){
		ig.game.tutorial();
	}),	

	exitButton : new ig.Button("SalirDelJuego.png", ui, 0.5 * ig.global.game.width - ((587/90) * 0.16 * ig.global.game.height)/2, 0.60	* ig.global.game.height, 0.16 * ig.global.game.height,1, function (){
		ig.game.finishFromPause();
	}),			
		
	draw : function(){

		var ctx = ig.system.context;		
		ctx.fillStyle = 'black';
		ctx.globalAlpha = 0.90;
		ctx.fillRect(0,0,ig.global.game.width,ig.global.game.height);		
		ctx.globalAlpha = 1;		
	
		this.continueButton.draw();		
		this.tutorialButton.draw();	
		this.exitButton.draw();	

	},
	
	update: function() {
	
		this.continueButton.update();		
		this.tutorialButton.update();	
		this.exitButton.update();	
	
		this.parent();
   }	
});

});