ig.module(
	'game.entities.top'
)
.requires(
	'impact.entity'
)
.defines(function(){

EntityTop = ig.Entity.extend({

	collides: ig.Entity.COLLIDES.NEVER,
	
	topBar : new ig.UIObject("PointsPanel.png", ui, 0.005 * ig.global.game.height, 0.005 * ig.global.game.height, 0.55 * ig.global.game.width * 59/744,1),

	pauseButton : new ig.Button("Pause.png", ui, ig.global.game.width - 0.005 * ig.global.game.height - ((100/90) * 0.13 * ig.global.game.height), 0.005 * ig.global.game.height, 0.13 * ig.global.game.height,1, function (){
		if(ig.game.paused == 0){
			ig.game.pause();
		};
	}),	

	soundOnButton : new ig.Button("SoundOn.png", ui, ig.global.game.width - 2 * 0.005 * ig.global.game.height - 2 * ((100/90) * 0.13 * ig.global.game.height), 0.005 * ig.global.game.height, 0.13 * ig.global.game.height,1, function (){
		if(ig.game.paused == 0){
			ig.game.disableSound();
		};
	}),	
	
	soundOffButton : new ig.Button("SoundOff.png", ui, ig.global.game.width - 2 * 0.005 * ig.global.game.height - 2 * ((100/90) * 0.13 * ig.global.game.height), 0.005 * ig.global.game.height, 0.13 * ig.global.game.height,1, function (){
		if(ig.game.paused == 0){
			ig.game.enableSound();
		};
	}),	
	
	scoreText : null,
	timeText : null,
	lapText : null,
	
	init : function(x, y, settings){
		this.parent(x, y, settings);
		this.scoreText = new ig.TextLine(ig.game.score+'/'+ ig.game.scoreTarget,Math.floor(this.topBar.w * 0.42),Math.floor(this.topBar.x + this.topBar.h * 0.51), Math.floor( this.topBar.h * 0.65 ),'AMCAP','middle','right','white',1);
		this.timeText = new ig.TextLine("02:00",Math.floor(this.topBar.w * 0.71),Math.floor(this.topBar.x + this.topBar.h * 0.51), Math.floor( this.topBar.h * 0.65 ),'AMCAP','middle','right','white',1);
		this.lapText = new ig.TextLine(" ETAPA "+ig.game.level,Math.floor(this.topBar.w * 0.99), Math.floor(this.topBar.x + this.topBar.h * 0.51), Math.floor( this.topBar.h * 0.65 ),'AMCAP','middle','right','white',1);
	},
	
	draw : function(){
		this.topBar.draw();	
		this.pauseButton.draw();
		if(window.config.sound == 1){this.soundOnButton.draw();}else{this.soundOffButton.draw();};		
		this.scoreText.draw();	
		this.timeText.draw();	
		this.lapText.draw();	
	},
	
	update: function() {
	
		if(ig.game.paused == 0){
			this.pauseButton.update();	
			if(window.config.sound == 1){this.soundOnButton.update();}else{this.soundOffButton.update();};		

			var hours = Math.floor(Math.abs(ig.game.timer.delta())/60);
			if(hours < 10){ hours = '0' + hours;}
			var mins = Math.floor(Math.abs(ig.game.timer.delta())%60);
			if(mins < 10){ mins = '0' + mins;}		
			if(ig.game.timer.delta() < 0){this.timeText.text = hours + ':' + mins;};	
			
			this.scoreText.text = ig.game.score+'/'+ ig.game.scoreTarget;
		}
		
		this.parent();
   }	
});

});