ig.module(
	'game.entities.tutorial2'
)
.requires(
	'impact.entity'
)
.defines(function(){

EntityTutorial2 = ig.Entity.extend({

	collides: ig.Entity.COLLIDES.NEVER,
	
	prevButton : new ig.Button("Prev.png", ui, 0.03 * ig.global.game.height, ig.global.game.height - 0.03 * ig.global.game.height - 0.09 * ig.global.game.height, 0.09 * ig.global.game.height,1, function (){
		ig.game.tutorial();
	}),	
	
	nextButton : new ig.Button("Next.png", ui, ig.global.game.width - 0.03 * ig.global.game.height - ((107/90) * 0.09 * ig.global.game.height), ig.global.game.height - 0.03 * ig.global.game.height - 0.09 * ig.global.game.height, 0.09 * ig.global.game.height,1, function (){
		ig.game.tutorial3();
	}),	
	
	backButton : new ig.Button("Volver.png", ui, ig.global.game.width - 0.03 * ig.global.game.height - ((224/90) * 0.09 * ig.global.game.height), 0.03 * ig.global.game.height, 0.09 * ig.global.game.height,1, function (){
		if(ig.game.getEntityByName('bikers')){ ig.game.closeTutorials(); }else{ ig.game.intro(); };
	}),		
	
	biker1Image : new ig.UIObject("BikerHand.png", ui, Math.floor( 0.12 * ig.global.game.width ), Math.floor( 0.20 * ig.global.game.height )  , 0.32 * ig.global.game.height , 1),			
	biker2Image : new ig.UIObject("MovistarHand.png", ui, Math.floor( 0.12 * ig.global.game.width ), Math.floor( 0.60 * ig.global.game.height )  , 0.32 * ig.global.game.height , 1),			
	
		
	init: function( x, y, settings ) {
		this.parent(x, y, settings);
		clearMouse();
	},			
		
	titleText : new ig.TextLine("TUTORIAL > MÉTODO", Math.floor( 0.045 * ig.global.game.height ), Math.floor( 0.045 * ig.global.game.height ), Math.floor( 0.06 * ig.global.game.height ),'HCH', 'top', 'left', '#FFFFFF',1),	
	text1Line1 : new ig.TextLine("Pulsa en los ciclistas rivales para ralentizarlos.",Math.floor( 0.36 * ig.global.game.width ),Math.floor( 0.24 * ig.global.game.height ), Math.floor( 0.065 * ig.global.game.height ),'HCM','top','left','white',1),
	text1Line2 : new ig.TextLine("¡Tócalos sólo cuando se escapen del pelotón",Math.floor( 0.36 * ig.global.game.width ),Math.floor( 0.32 * ig.global.game.height ), Math.floor( 0.065 * ig.global.game.height ),'HCM','top','left','#ed4f4f',1),
	text1Line3 : new ig.TextLine("o perderás puntos!",Math.floor( 0.36 * ig.global.game.width ),Math.floor( 0.40 * ig.global.game.height ), Math.floor( 0.065 * ig.global.game.height ),'HCM','top','left','#ed4f4f',1),	
	text2Line1 : new ig.TextLine("Al final de cada etapa habrá un sprint hacia la meta.",Math.floor( 0.36 * ig.global.game.width ),Math.floor( 0.64 * ig.global.game.height ), Math.floor( 0.065 * ig.global.game.height ),'HCM','top','left','white',1),
	text2Line2 : new ig.TextLine("Pulsa de manera rápida a los ciclistas del Movistar Team",Math.floor( 0.36 * ig.global.game.width ),Math.floor( 0.72 * ig.global.game.height ), Math.floor( 0.065 * ig.global.game.height ),'HCM','top','left','white',1),
	text2Line3 : new ig.TextLine("para aumentar su velocidad y alzarte con la victoria.",Math.floor( 0.36 * ig.global.game.width ),Math.floor( 0.80 * ig.global.game.height ), Math.floor( 0.065 * ig.global.game.height ),'HCM','top','left','white',1),	
	
	
	draw : function(){

		var ctx = ig.system.context;	

		//Background
		ctx.fillStyle = 'black';
		ctx.fillRect(0,0,ig.global.game.width,ig.global.game.height);			
		
		this.titleText.draw();
		
		this.biker1Image.draw();
		this.biker2Image.draw();		
		
		//Title line		
		ctx.fillStyle = '#5e5e5e';
		ctx.fillRect(0, 0.15 * ig.global.game.height, ig.global.game.width, 1);

		this.text1Line1.draw();
		this.text1Line2.draw();
		this.text1Line3.draw();

		//Horizontal Line	
		ctx.fillStyle = '#5e5e5e';
		ctx.fillRect(0, 0.55 * ig.global.game.height, ig.global.game.width, 1);			

		this.text2Line1.draw();
		this.text2Line2.draw();
		this.text2Line3.draw();		

		this.prevButton.draw();
		this.nextButton.draw();
		this.backButton.draw();			

	},
	
	update: function() {
		this.prevButton.update();	
		this.nextButton.update();			
		this.backButton.update();			
		this.parent();
   }	
});

});