ig.module(
	'game.main' 
)
.requires(
	'impact.game',
	'impact.font',
	'game.globals',	
	'plugins.irontec',		
	'plugins.scale',
	'plugins.score',		
	'plugins.UIObject',		
	'plugins.button',	
	'plugins.textLine',		
	'plugins.parallaxAnimation',		
	'plugins.bikerAnimation',		
	'plugins.obstacleAnimation',		
	'game.entities.intro',	
	'game.entities.tutorial',	
	'game.entities.tutorial2',	
	'game.entities.tutorial3',	
	'game.entities.pause',	
	'game.entities.nextLevel',			
	'game.entities.finish',		
	'game.entities.background',	
	'game.entities.top',			
	'game.entities.bikers'	

)
.defines(function(){

loader = ig.Loader.extend({
	draw: function() {
	}
}),
	
MyGame = ig.Game.extend({

	timer : new ig.Timer(), 
	gameMusic : new ig.Sound('media/sounds/music.mp3',false),
	musicActived : 0,
	badSound : new ig.Sound('media/sounds/bad.mp3'), 
	goodSound : new ig.Sound('media/sounds/good.mp3'),
	paused : 0, finished : 0, level: 1, score : 0, scoreTarget : 0, speedFactor : 0, vivefanScore : 0, recordLevel : 0,

    init: function() {
		//ig.ua.iOS = 0; //MODO DEBUGGING IPHONE
		ig.game.initRemoteStorage();
		ig.irontec.initGame();
	},

	initRemoteStorage : function(){
		if (window.configLoaded === false) {
			var that = this;
			window.setTimeout(function() {
				that.initRemoteStorage();			
			},400);
			return;
		}
		
		if(!window.config) {
			window.config = {};
		}
		if (typeof window.config.sound == 'undefined') {
			window.config.sound = 1;
		}
		if (typeof window.config.recordLevel == 'undefined') {
			window.config.recordLevel = 0;
		}		
		ig.irontec.saveToRemoteStorage();
        ig.game.initMusic();
        ig.game.recordLevel = window.config.recordLevel;
        ig.game.intro();
	},	
	
	initMusic : function(){	
		if(!ig.ua.mobile){
			ig.music.add(this.gameMusic);
			ig.music.loop = true;	
			ig.music.play();
		}
		
		if(window.config.sound == 0){
			if(!ig.ua.mobile){ig.music.volume = 0;};			
		}else{	
			if(!ig.ua.mobile){ig.music.volume = 1;};
			ig.irontec.enableMusic(this.gameMusic.path);
		}			
	},
	
	playSound : function(sound){
		if(window.config.sound == 1){
			if(!ig.ua.mobile){ eval('this.' + sound).play(); };
			if(ig.ua.iOS){ eval('this.' + sound).play(); };
			if(ig.ua.winPhone || ig.ua.android){ig.irontec.playSound(eval('this.' + sound));};
		}
	},	

	enableSound : function(){
		window.config.sound = 1;
		ig.music.volume = 1;
		ig.irontec.enableMusic(this.gameMusic.path);
		ig.irontec.saveToRemoteStorage();		
	},		
	
	disableSound : function(){
		window.config.sound = 0;
		ig.music.volume = 0; 
		ig.irontec.disableMusic();
		ig.irontec.saveToRemoteStorage();		
	},
		
	intro : function(){
		if(ig.game.getEntityByName('tutorial')){ ig.game.getEntityByName('tutorial').kill(); };		
		if(ig.game.getEntityByName('tutorial2')){ ig.game.getEntityByName('tutorial2').kill(); };		
		if(ig.game.getEntityByName('tutorial3')){ ig.game.getEntityByName('tutorial3').kill(); };		
		ig.game.spawnEntity(EntityIntro, 0, 0, {zIndex: 0, name : 'intro'});
	},
	
    tutorial: function() {
		if(ig.game.getEntityByName('intro')){ ig.game.getEntityByName('intro').kill(); };	
		if(ig.game.getEntityByName('tutorial2')){ ig.game.getEntityByName('tutorial2').kill(); };				
		if(ig.game.getEntityByName('tutorial3')){ ig.game.getEntityByName('tutorial3').kill(); };	
		ig.game.spawnEntity(EntityTutorial, 0, 0, {zIndex: 0, name : 'tutorial'});			
	},	
	
    tutorial2: function() {
		if(ig.game.getEntityByName('tutorial')){ ig.game.getEntityByName('tutorial').kill(); };		
		if(ig.game.getEntityByName('tutorial3')){ ig.game.getEntityByName('tutorial3').kill(); };		
		ig.game.spawnEntity(EntityTutorial2, 0, 0, {zIndex: 0, name : 'tutorial2'});			
	},	

    tutorial3: function() {
		if(ig.game.getEntityByName('tutorial')){ ig.game.getEntityByName('tutorial').kill(); };		
		if(ig.game.getEntityByName('tutorial2')){ ig.game.getEntityByName('tutorial2').kill(); };		
		ig.game.spawnEntity(EntityTutorial3, 0, 0, {zIndex: 0, name : 'tutorial3'});			
	},		
	
	closeTutorials : function() {
		if(ig.game.getEntityByName('tutorial')){ ig.game.getEntityByName('tutorial').kill(); };		
		if(ig.game.getEntityByName('tutorial2')){ ig.game.getEntityByName('tutorial2').kill(); };			
		if(ig.game.getEntityByName('tutorial3')){ ig.game.getEntityByName('tutorial3').kill(); };			
	},
	
    pause: function() {
		this.paused = 1;
		this.timer.pause();
		ig.game.spawnEntity(EntityPause, 0, 0, {zIndex: 8, name : 'pause'});			
	},		
	
	unpause : function(){
		this.paused = 0;
		this.timer.unpause();
		if(ig.game.getEntityByName('pause')){ ig.game.getEntityByName('pause').kill(); };			
	},
	
	changeScore : function(points,x,y){
		if(points > 0){
			this.playSound('goodSound');
		}else{
			this.playSound('badSound');
		}
		if(this.score + points > 0){
			this.score = this.score + points;
		}else{
			this.score = 0;
		}		
		var newScore = new ig.Score(points,x,y);	
		ig.game.getEntityByName('bikers').scores.push(newScore);
	},

	calculateVivefanScore: function(){
		this.vivefanScore = (this.level-1) * 6;
	},	
	
	closeGameEntities : function(){
		if(ig.game.getEntityByName('top')){ ig.game.getEntityByName('top').kill(); };
		if(ig.game.getEntityByName('background')){ ig.game.getEntityByName('background').kill(); };	
		if(ig.game.getEntityByName('bikers')){ ig.game.getEntityByName('bikers').kill(); };		
		if(ig.game.getEntityByName('pause')){ ig.game.getEntityByName('pause').kill(); };				
		if(ig.game.getEntityByName('finish')){ ig.game.getEntityByName('finish').kill(); };
		if(ig.game.getEntityByName('nextLevel')){ ig.game.getEntityByName('nextLevel').kill(); };
	},
	
	play: function(){
		ig.game.closeGameEntities();
		ig.game.finished = 0;
		ig.game.score = 0;
		ig.game.clearColor = '#edeef8';
		ig.game.scoreTarget = 2500 + ig.game.level * 200;
		ig.game.speedFactor = 0.014 + 0.0003 * ig.game.level;
		if(ig.game.getEntityByName('intro')){ ig.game.getEntityByName('intro').kill(); };		
		ig.game.spawnEntity(EntityBackground, 0, 0, {zIndex: 0, name : 'background'});	
		ig.game.spawnEntity(EntityTop, 0, 0, {zIndex: 1, name : 'top'});	
		ig.game.spawnEntity(EntityBikers, 0, 0, {zIndex: 2, name : 'bikers'});				
		this.timer.set(ig.global.game.raceTime);
	},

	exit : function(){
		ig.game.closeGameEntities();
		ig.irontec.exitGame();		
	},
	
	finishFromPause : function(){
		if(ig.game.getEntityByName('pause')){ ig.game.getEntityByName('pause').kill(); };
		ig.game.finished = 1;
		if(this.vivefanScore > 0){ 
			ig.game.calculateVivefanScore();
			ig.irontec.savePoints(this.vivefanScore); 
		};		
		ig.game.spawnEntity(EntityFinish, 0, 0, {zIndex: 3, name : 'finish'});			
	},
	
	finish : function(){
		ig.game.finished = 1;	
		if(ig.game.score >= ig.game.scoreTarget){
			this.level++;
			if(this.level > window.config.recordLevel){ 
				window.config.recordLevel = this.level;
				ig.irontec.saveToRemoteStorage();	
			};
			ig.game.calculateVivefanScore();
			if(this.level<16){
				ig.game.spawnEntity(EntityNextLevel, 0, 0, {zIndex: 3, name : 'nextLevel'});	
			}else{
				ig.game.spawnEntity(EntityFinish, 0, 0, {zIndex: 3, name : 'finish'});
				ig.irontec.savePoints(this.vivefanScore);				
			}			
		}else{
			if(this.vivefanScore > 0){ 
				ig.game.calculateVivefanScore();
				ig.irontec.savePoints(this.vivefanScore); 
			};		
			ig.game.spawnEntity(EntityFinish, 0, 0, {zIndex: 3, name : 'finish'});		
		}
	},
	
	update : function(){
		ig.global.game.speed = ig.game.speedFactor * ig.global.game.width * ig.system.tick;
		this.parent();
	}	
		        
});

ig.Sound.use = [ig.Sound.FORMAT.MP3];
ig.main( '#canvas', MyGame, 60,  ig.global.game.width, ig.global.game.height, 1, loader);

});
