/*
* ImpactJS Parallax Animation Plugin
* Alex Maestre - August 2014
*
*/
ig.module(
    'plugins.UIObject'
)
.requires(
	'impact.image' 
)

.defines(function() { "use strict";
	
	ig.UIObject = ig.Class.extend({
	
		atlasPNG : new ig.Image( 'media/img/ui.png' ),		
		
		sx : 0, sy : 0, sw : 0, sh : 0, w : 0, h : 0, x : 0, y : 0, alpha: 1, rotated : false,
	
		init : function(filename, atlas, x, y, finalHeight, alpha){
			for(var i=0; i<=atlas.length-1; i++){
				if(atlas[i].filename == filename){
					this.x = x;
					this.y = y;				
					this.sx = atlas[i].frame.x;
					this.sy = atlas[i].frame.y;
					this.alpha = alpha;
					this.rotated = atlas[i].rotated;
					if(atlas[i].rotated == false){
						this.sw = atlas[i].frame.w;
						this.sh = atlas[i].frame.h;
					}else{
						this.sw = atlas[i].frame.h;
						this.sh = atlas[i].frame.w;						
					}	
					this.h = Math.round(finalHeight);
					this.w = Math.round(finalHeight * atlas[i].frame.w/atlas[i].frame.h);						
				}
			}			
		},
		
		draw : function (){

			var ctx = ig.system.context;
			var x = 0, y = 0, w = 0, h = 0;

			if(this.rotated == true){ 
				w = this.h;
				h = this.w;
				x = 0; 
				y = 0;
				ctx.save();			
				ctx.translate(this.x, w + this.y);			
				ctx.rotate(Math.PI/180 * -90); 				
			}else{
				w = this.w;
				h = this.h;
				x = this.x;		
				y = this.y;			
			}		
			ctx.globalAlpha = this.alpha;
			ctx.drawImage(this.atlasPNG.data, this.sx, this.sy, this.sw, this.sh, x, y, w, h);
			ctx.globalAlpha = 1;
			if(this.rotated == true){
				ctx.restore();
			}; 
		
		
		}
			
	});
	

});