/*
* ImpactJS Parallax Animation Plugin
* Alex Maestre - August 2014
*
*/
ig.module(
    'plugins.button'
)
.requires(
	'plugins.UIObject',
	'impact.image'
)

.defines(function() { "use strict";
	
	ig.Button = ig.Class.extend({
	
		button : null,
		callback : null,
		rotated : null,
		
		init : function(filename, atlas, x, y, finalHeight, alpha, callback){
			this.button = new ig.UIObject(filename, atlas, x, y, finalHeight, alpha);	
			this.callback = callback;
			this.rotated = this.button.rotated;
		},
		
		draw : function (){
			this.button.draw();	
		},
		
		update : function(){
			
			if(
				lastMouse.x > this.button.x && lastMouse.x < this.button.x + this.button.w && 
				lastMouse.y > this.button.y && lastMouse.y < this.button.y + this.button.h 
			){
				this.button.alpha = 0.85;
			}else{
				this.button.alpha = 1;
			};
			
			if(
				lastClick.x > this.button.x && lastClick.x < this.button.x + this.button.w && 
				lastClick.y > this.button.y && lastClick.y < this.button.y + this.button.h
			){
				clearMouse();
				this.callback();
			};
			
		}
			
	});
	

});