ig.module(
    'plugins.irontec'
)
.defines(function() {
	"use strict";

	if(ig.ua.winPhone && typeof window.external != 'undefined'){
		window.console = {
			log: function (str) { window.external.Notify(str); }
		};
		window.onerror = function (e) {
			console.log("window.onerror ::" + JSON.stringify(e));
		};
		console.log("Installed console !");
	};
	
	ig.irontec = {},

	ig.irontec.iOSIFrame = function(url) {
		var iframe = document.createElement("iframe");
		iframe.setAttribute("width","1px");
		iframe.setAttribute("height","1px");
		iframe.setAttribute("src", url);
		document.documentElement.appendChild(iframe);
		setTimeout(function() {
				   iframe.parentNode.removeChild(iframe);
				   iframe = null;
		}, 1500);
    },
	
    ig.irontec.initGame = function() {
		if(ig.ua.winPhone && typeof window.external != 'undefined'){ window.external.notify("initGame;null"); };
		if(ig.ua.iOS){ ig.irontec.iOSIFrame("vivefan://initGame"); };
		if(ig.ua.android && typeof GOPlayInterface != 'undefined'){ GOPlayInterface.initGame(); };
	},
	
    ig.irontec.cancelGame = function() {
		if(ig.ua.winPhone && typeof window.external != 'undefined'){ window.external.notify("cancelGame;null"); };
		if(ig.ua.iOS){ ig.irontec.iOSIFrame("vivefan://cancelGame"); };
		if(ig.ua.android && typeof GOPlayInterface != 'undefined'){ GOPlayInterface.cancelGame(); };
	},
	
    ig.irontec.exitGame = function() {
		if(ig.ua.winPhone && typeof window.external != 'undefined'){ window.external.notify("exitGame;null"); };
		if(ig.ua.iOS){ ig.irontec.iOSIFrame("vivefan://exitGame"); };
		if(ig.ua.android && typeof GOPlayInterface != 'undefined'){ GOPlayInterface.exitGame(); };
	},
		
	ig.irontec.savePoints = function(points) {
		if(points < 10){points = 10;};
		if(points > 90){points = 90;};
		if(ig.ua.winPhone && typeof window.external != 'undefined'){ window.external.notify("savePoints;" + points); };
		if(ig.ua.iOS){ ig.irontec.iOSIFrame("vivefan://savePoints?score=" + points);};
		if(ig.ua.android && typeof GOPlayInterface != 'undefined'){ GOPlayInterface.savePoints(points); };
	},

	ig.irontec.saveToRemoteStorage = function() {	
		if(ig.ua.winPhone && typeof window.external != 'undefined'){ window.external.notify("saveToRemoteStorage;" + JSON.stringify(window.config)); };
		if(ig.ua.iOS){ ig.irontec.iOSIFrame("vivefan://saveToRemoteStorage?config=" + JSON.stringify(window.config));};
		if(ig.ua.android && typeof GOPlayInterface != 'undefined'){ GOPlayInterface.saveToRemoteStorage(JSON.stringify(window.config)); };	
	},
	
	ig.irontec.enableMusic = function(path) {
		if(ig.game.musicActived == 0){
			if(ig.ua.winPhone && typeof window.external != 'undefined'){ window.external.notify("playBackgroundSound;" + path); };	
			if(ig.ua.iOS){ig.irontec.iOSIFrame("vivefan://playBackgroundSound?file=" + path); }
			if(ig.ua.android && typeof GOPlayInterface != 'undefined'){ GOPlayInterface.playBackgroundSound(path); };	
			ig.game.musicActived=1;
		};
	},		
	
	ig.irontec.disableMusic = function() {	
		if(ig.game.musicActived == 1){	
			if(ig.ua.winPhone && typeof window.external != 'undefined'){ window.external.notify("stopBackgroundSound;null"); };	
			if(ig.ua.iOS){ig.irontec.iOSIFrame("vivefan://stopBackgroundSound")}
			if(ig.ua.android && typeof GOPlayInterface != 'undefined'){ GOPlayInterface.stopBackgroundSound(); };	
			ig.game.musicActived=0;
		};
	},
	
	ig.irontec.playSound = function(sound){
		if(ig.ua.winPhone && typeof window.external != 'undefined'){ window.external.notify("playSound;" + sound.path.replace(".mp3", ".wav")); };
		if(ig.ua.android && typeof GOPlayInterface != 'undefined'){ GOPlayInterface.playSound(sound.path); };		
	}
	

});