/*
* Mouse Functions
* Alex Maestre - August 2014
*/

var mouse = {}, lastMouse = {}, click = {}, lastClick = {}, release = {}, isMobile = 0;

if ( navigator.userAgent.match(/iPhone/i) ||
	 navigator.userAgent.match(/iPad/i) ||
	 navigator.userAgent.match(/iPod/i)
	 ) {
		document.ontouchmove = function(e) {e.preventDefault()};
}

if (navigator.userAgent.match(/Android/i) ||
	 navigator.userAgent.match(/webOS/i) ||
	 navigator.userAgent.match(/iPhone/i) ||
	 navigator.userAgent.match(/iPad/i) ||
	 navigator.userAgent.match(/iPod/i) ||
	 navigator.userAgent.match(/BlackBerry/) || 
	 navigator.userAgent.match(/Windows Phone/i) || 
	 navigator.userAgent.match(/ZuneWP7/i)
	 ) {
		isMobile = 1;
}

if(isMobile){

	function touchDrag(e) {
		e.preventDefault();
		lastMouse.x = mouse.x;
		lastMouse.y = mouse.y;			
		if (window.navigator.msPointerEnabled){
			mouse.x = e.clientX;
			mouse.y = e.clientY;
		}else{
			mouse.x = e.changedTouches[0].pageX;
			mouse.y = e.changedTouches[0].pageY;
		}     
	}   
		  
	function touchClick(e) {
		e.preventDefault();		
		if (window.navigator.msPointerEnabled){
			click.x = e.clientX;
			click.y = e.clientY;
		}else{
			click.x = e.changedTouches[0].pageX;
			click.y = e.changedTouches[0].pageY;
		}   			 
	}

	function touchRelease(e) {
		if (window.navigator.msPointerEnabled){
			release.x = e.clientX;
			release.y = e.clientY;
		}else{
			release.x = e.changedTouches[0].pageX;
			release.y = e.changedTouches[0].pageY;
		}     
			lastClick.x = click.x; 
			lastClick.y = click.y;
			click.x = 0; 
			click.y = 0;	
			lastMouse.x = 0;
			lastMouse.y = 0;	
	}
	
   if (window.navigator.msPointerEnabled) {
		canvas.addEventListener("MSPointerDown", touchClick, true); 
		canvas.addEventListener("MSPointerMove", touchDrag, true);
		canvas.addEventListener("MSPointerUp", touchRelease, true);       
   }else{
		canvas.addEventListener("touchstart", touchClick, true);   
		canvas.addEventListener("touchmove", touchDrag, true); 
		canvas.addEventListener("touchend", touchRelease, true); 		
   }
}else{

	function mouseDrag(e) {
		lastMouse.x = mouse.x;
		lastMouse.y = mouse.y;
		mouse.x = e.pageX;
		mouse.y = e.pageY;
	}	
	
	function mouseClick(e) {
		click.x = e.pageX;
		click.y = e.pageY;         
	}

	function mouseRelease(e) {
		release.x = e.pageX;
		release.y = e.pageY;       
		lastClick.x = click.x; 
		lastClick.y = click.y;
		click.x = 0; 
		click.y = 0;	
		lastMouse.x = 0;
		lastMouse.y = 0;    
	}  		
	canvas.addEventListener("mousedown", mouseClick, true); 
	canvas.addEventListener("mousemove", mouseDrag, true);   
	canvas.addEventListener("mouseup", mouseRelease, true); 
}

function clearMouse(){
	click.x = 0;
	click.y = 0;
	release.x = 0;
	release.y = 0;
	lastClick.x = 0;
	lastClick.y = 0;		
	lastMouse.x = 0;
	lastMouse.y = 0;			
}