/*
* ImpactJS Parallax Animation Plugin
* Alex Maestre - August 2014
*
*/
ig.module(
    'plugins.parallaxAnimation'
)
.requires(
	'impact.image' 
)

.defines(function() { "use strict";
	
	ig.ParallaxAnimation = ig.Class.extend({
	
		atlasPNG : new ig.Image( 'media/img/backgrounds.png' ),		
		
		sx : 0, sy : 0, sw : 0, sh : 0, w : 0, h : 0, ox : 0, oy : 0, mx : 0, repeats : 1, rotated : false,	minX : [], speed : 1,
	
		init : function(filename, atlas, offsetX, offsetY, finalHeight, marginX, repeats, speed){
			for(var i=0; i<=atlas.length-1; i++){
				if(eval(atlas)[i].filename == filename){
					this.sx = atlas[i].frame.x;
					this.sy = atlas[i].frame.y;
					if(atlas[i].rotated == false){
						this.sw = atlas[i].frame.w;
						this.sh = atlas[i].frame.h;
						this.w = Math.round(finalHeight * atlas[i].frame.w/atlas[i].frame.h);
						this.h = Math.round(finalHeight);	
					}else{
						this.sw = atlas[i].frame.h;
						this.sh = atlas[i].frame.w;
						this.w = Math.round(finalHeight);
						this.h = Math.round(finalHeight * atlas[i].frame.w/atlas[i].frame.h);							
					}	
					this.rotated = atlas[i].rotated;
					for(var j=0; j<= repeats - 1; j++){
						atlas[i].rotated ? this.minX[j] = offsetX + Math.round(j * (this.h + marginX - 1)) : this.minX[j] = offsetX + Math.round(j * (this.w + marginX - 1));	
					}		
					this.mx = marginX;
					this.ox = offsetX;
					this.oy = offsetY;
					this.repeats = repeats;
					this.speed = speed;					
				}
			}			
		},
		
		draw : function (){

			var ctx = ig.system.context;
			var x = 0, y = 0;
			
			for(var i=0; i<=this.repeats - 1; i++){
				if(this.rotated == true){ 
					ctx.save();			
					ctx.translate(this.minX[i], this.w + this.oy);			
					ctx.rotate(Math.PI/180 * -90); 
					x = 0; 
					y = 0;					
				}else{
					x = this.minX[i];		
					y = this.oy;			
				}		
				ctx.drawImage(this.atlasPNG.data, this.sx, this.sy, this.sw, this.sh, x, y, this.w, this.h);
				if(this.rotated == true){
					ctx.restore();
				}; 
			}		
		
		},
		
		update : function(){
		
			if(ig.game.paused==0 && ig.game.finished==0){		
				for(var i=0; i<=this.repeats - 1; i++){		
					this.minX[i] = this.minX[i] - this.speed * 3 * ig.global.game.speed;
					if(this.repeats>1){ //Only for objects with more than one frame
						if(this.rotated == false) {
							if(this.minX[i] <= - this.w){ this.minX[i] = this.minX[i] + this.repeats * (this.w + this.mx - 1) };
						}else{
							if(this.minX[i] <= - this.h){ this.minX[i] = this.minX[i] + this.repeats * (this.h - 1) };
						}
					}
				}
			}
		
		}
			
	});
	

});