/*
* ImpactJS Score Animations Plugin
* Alex Maestre - August 2014
*
*/
ig.module(
    'plugins.score'
)
.requires(
	'plugins.textLine'
)

.defines(function() { "use strict";
	
	ig.Score = ig.TextLine.extend({
		
		init : function (score,x,y){
			if(score>0){var color = '#00ff00'}else{var color = '#ff0000'};
			var fontSize = Math.floor( 0.07 * ig.global.game.height );
			this.parent(score, x, y, fontSize,'AMCAP', 'top', 'left', color,0);
			this.finished = 0;
			var timeline = new TimelineMax({repeat:0,onComplete:this.finish()});
			var tw1 = TweenMax.to(this, 1, {y: 2/3 * y, alpha:1, ease:Linear.easeNone});
			var tw2 = TweenMax.to(this, 1, {y: 1/3 * y, alpha:0, ease:Linear.easeNone});
			timeline.add(tw1);
			timeline.add(tw2,1);
			timeline.play();
		},
		
		finish : function(){
			this.finished = 1;
		},
						
		draw : function (){
			this.parent();
		},
		
		update : function(){
		}
			
	});
	

});